SystemOrganization addCategory: #'SISS-Core'!
SystemOrganization addCategory: #'SISS-Meta'!

!AssignmentNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:44'!
sexpWith: aDictionary obj: obj

	| elems |
	elems _ WriteStream on: (Array new: 2).
	elems nextPut: (SExpElement keyword: #variable attributes: (SExpAttributes with: #value->variable key)).
	elems nextPut: (value sexpWith: aDictionary obj: obj).

	^ SExpElement keyword: #assign elements: elems contents.
! !

!QuickGuideMorph class methodsFor: '*siss-instance creation' stamp: 'bf 8/14/2010 13:55'!
convertProjectsWithBooksToSISSIn: dir to: outDir

	| p book |
	dir fileNames do: [:f |
		(f endsWith: '.pr') ifTrue: [
			p _ ProjectLoading loadName: f stream: (dir readOnlyFileNamed: f) fromDirectory: dir withProjectView: nil.
			book _ p world submorphs detect: [:b | b isMemberOf: BookMorph] ifNone: [nil].
			book ifNotNil: [
				book hidePageControls.
				book storeAsDataStreamNamed: (outDir fullNameFor: (f copyUpTo: $.), '.sexp.data.gz').
			].
			p okToChangeSilently.
		].
	].
! !

!TTCFontSet class methodsFor: '*siss-instance creation' stamp: 'yo 12/8/2007 00:24'!
familyName: aName size: aSize emphasized: emphasisCode

	^TTCFont familyName: aName pointSize: aSize emphasized: emphasisCode! !

!TTCFontSet methodsFor: '*siss-interface' stamp: 'tfel 8/5/2016 16:49'!
sissStoreString

	^ self fontArray first fontNameWithPointSize, ' ', self fontArray first emphasis asString! !

!Workspace class methodsFor: '*siss-instance creation' stamp: 'yo 2/20/2008 15:23'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| b dict bindings |
	b _ self new.
	idref ifNotNil: [to at: idref put: b].
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	bindings _ dict at: #bindings ifAbsent: [].
	bindings ifNotNil: [b setBindings: bindings].
	b contents: (dict at: #contents).
	b acceptsDroppingMorphForReference: (dict at: #acceptDroppedMorphs).
	^ b.
! !

!Workspace methodsFor: '*siss-interface' stamp: 'yo 2/20/2008 14:19'!
sissExportSpecification

	^ #(('contents' #sissGetContents)
		('bindings' #bindings)
		('acceptDroppedMorphs' #acceptsDroppingMorphForReference)
	)! !

!Workspace methodsFor: '*siss-interface' stamp: 'yo 2/21/2008 16:26'!
sissGetContents

	| textMorph |
	textMorph _ self dependents detect: [:dep | dep isKindOf: PluggableTextMorph] ifNone: [nil].
	textMorph notNil ifTrue: [^ textMorph textMorph paragraph text].

	^ ''.
! !

!Workspace methodsFor: '*siss-interface' stamp: 'yo 2/20/2008 14:31'!
sissSetContents: aText

	| textMorph |
	textMorph _ self dependents detect: [:dep | dep isKindOf: PluggableTextMorph] ifNone: [nil].
	textMorph notNil ifTrue: [textMorph setText: aText asText].
! !

MMeta subclass: #MSExpParser
	instanceVariableNames: 'ksexpMemo ksexpNextPos componentMemo componentNextPos nameMemo nameNextPos keywordMemo keywordNextPos stringMemo stringNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Meta'!

!MSExpParser class methodsFor: 'as yet unclassified' stamp: 'yo 3/7/2007 15:21'!
test1

	| str1 str2 str3 |
	str1 _ '(script :name "testscript1:" :type "Player" :player "12"
		(parameter :name "parameter" :type "Number" :position "1") 
		(sequence
			(loop :type "repeat"
				(initial (literal :value "0"))
				(increment (literal :value "1"))
				(test (send :type "Number"
		(selector :selector "+")
		(send :type "Number"
			(selector :getter "x")
			(literal :type "Player" :value "self"))
		(literal :type "Number" :value "1")))
				(sequence
					(assign :type "Number" :updating "Incr:" :property "x"
						(literal :type "Player" :value "4")
						(send :type "Number"
							(selector :selector "+")
							(literal :type "Number" :value "244.0")
							(literal :type "Number" :value "1")))))))'.

	str2 _ (MSExpParser parse: str1 with: #ksexp) prettyString.
	str3 _ (MSExpParser parse: str2 with: #ksexp) prettyString.

	(StringHolder new textContents:
			(TextDiffBuilder buildDisplayPatchFrom: str2 to: str3))
			openLabel: 'original sexp and new sexp'.! !

!MSExpParser class methodsFor: 'as yet unclassified' stamp: 'yo 2/28/2007 17:21'!
tokenizer

	^ MSExpTokenizer.! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/28/2007 17:08'!
component ::=
	(<ksexp> | <keyword>:k <string>:s `k->s`)! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializecomponent
	componentMemo _ Array new: stream size + 1 withAll: Untried.
	componentNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializekeyword
	keywordMemo _ Array new: stream size + 1 withAll: Untried.
	keywordNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializeksexp
	ksexpMemo _ Array new: stream size + 1 withAll: Untried.
	ksexpNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializename
	nameMemo _ Array new: stream size + 1 withAll: Untried.
	nameNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializestring
	stringMemo _ Array new: stream size + 1 withAll: Untried.
	stringNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:09'!
keyword ::=
	<anything>:s ?`s is: #keyword` `s value`! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:09'!
ksexp ::=
	#'(' <name>:n <component>*:c #')' `SExpElement keyword: n value components: c`! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:10'!
name ::=
	<anything>:s ?`s is: #name` `s value`! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:11'!
string ::=
	<anything>:s ?`s is: #string` `s value`! !

!ReturnNode methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 15:14'!
sexpWith: aDictionary

	| n |
	n _ SExpElement keyword: #return.
	n addElements: (Array with: (expr sexpWith: aDictionary)).
	^ n.

! !

!ReturnNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 12:56'!
sexpWith: aDictionary obj: obj

	| n |
	n _ SExpElement keyword: #return.
	n addElements: (Array with: (expr sexpWith: aDictionary obj: obj)).
	^ n.

! !

!Browser class methodsFor: '*siss-private' stamp: 'yo 3/24/2007 08:52'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| b dict |
	b _ self new.
	idref ifNotNil: [to at: idref put: b].
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	b setClass: (Smalltalk at: (dict at: #selectedClassName) asSymbol) selector: nil.
	b openEditString: nil.
	^ b.
! !

!Browser methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 19:15'!
sissExportSpecification

	^ #(('selectedClassName' #selectedClassName)
		('metaClassIndicated' #metaClassIndicated))
! !

!Boolean class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ (sexp attributeAt: #value) = 'true'.
! !

!Boolean methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!WeakMessageSend methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	(varName at: 1) isDigit ifTrue: [
		self basicAt: varName asInteger put: childInst.
	] ifFalse: [
		self sissBasicInstVarNamed: varName put: childInst in: context
	].
! !

!CharacterSet class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:05'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!ParameterTile methodsFor: '*siss-interface' stamp: 'yo 4/2/2007 18:04'!
sexpWith: dictionary

	| myTypeString n |
	myTypeString _ self resultType.
	(self scriptEditor hasParameter and: [self scriptEditor typeForParameter = myTypeString])
		ifTrue:
			[n _ SExpElement keyword: #variable.
			(owner isMemberOf: TilePadMorph) ifTrue: [
				n attributeAt: #type put: owner type
			].
			n attributeAt: #name put: 'parameter1']
		ifFalse:
			[self error: ''].
	^ n.
! !

!VariableNode methodsFor: '*siss-interface' stamp: 'yo 3/24/2007 10:06'!
sexpWith: aDictionary obj: obj

	| newElem k |
	newElem _ SExpElement keyword: #variable.
	(key isKindOf: LookupKey) ifTrue: [
		k _ key value.
		k isPlayerLike ifTrue: [
			newElem attributeAt: #idref put: (aDictionary at: k) idref.
			newElem attributeAt: #type put: 'Player'.
		] ifFalse: [
			newElem attributeAt: #value put: key key.
		]
	] ifFalse: [
		newElem attributeAt: #value put: key.
		key = 'self' ifTrue: [
			newElem attributeAt: #type put: 'Player'.
		].
	].
	^ newElem.

! !

!SparseLargeTable class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:27'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!SparseLargeTable methodsFor: '*siss-private' stamp: 'yo 3/5/2007 12:36'!
sissContentsInto: sexp context: dictionary
	self sissInstVarsInto: sexp context: dictionary.
	self sissIndexFieldsInto: sexp context: dictionary.! !

!SparseLargeTable methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	(varName at: 1) isDigit ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self sissBasicInstVarNamed: varName put: childInst in: context
	].
! !

!KedamaTurtleMorph methodsFor: '*siss-interface' stamp: 'yo 4/6/2007 10:56'!
sissComeFullyUpOnReloadFrom: from to: to

	self player turtles compileAllAccessors.
	self player clonedSequentialStub compileAllAccessors.
	super sissComeFullyUpOnReloadFrom: from to: to.
! !

!BlockClosure class methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:10'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| ret |
	ret _ Compiler evaluate: (sexp attributeAt: #value) for: nil logged: false.
	idref ifNotNil: [to at: idref put: ret].
	^ ret.
! !

!BlockClosure methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:09'!
sissIsLiteral

	^ true.
! !

!BlockClosure methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:10'!
sissStoreString

	| node |
	node _ self decompile.
	^ (DialectStream dialect: #ST80 contents: [:strm | node printOn: strm indent: 0]) asString
! !

!DirectoryEntry class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:00'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!DirectoryEntry methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:45'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context
! !

!ColorSeerTile methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 12:38'!
sexpWith: dictionary 
	self error: 'should not reach here'.! !

!ByteArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:42'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst bytes |
	bytes _ (Base64MimeConverter mimeDecodeToBytes: (sexp attributeAt: #value) readStream) contents.
	inst _ self new: bytes size.
	inst replaceFrom: 1 to: bytes size with: bytes startingAt: 1.
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/23/2007 22:18'!
classFromClassName: aName

	^ Smalltalk at: aName asSymbol ifAbsent: [self error: ''. Object].
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/4/2007 01:43'!
findIdref: idref context: aDictionary 
	^ idref isNil
		ifTrue: [nil]
		ifFalse: [aDictionary at: idref ifAbsent: [nil]]! !

!Object methodsFor: '*siss-private' stamp: 'yo 2/27/2008 14:25'!
fromSexp: sexp from: from to: to
	| className classObj idref obj cls meta uniId |
	idref := self idrefFromSexp: sexp.
	(obj _ self findIdref: idref context: to) ifNotNil: [^ obj].

	meta _ sexp attributeAt: #metaclass ifAbsent: [''].
	uniId _ sexp attributeAt: #uniclass ifAbsent: [''].
	(uniId ~= '' and: [meta ~= 'true']) ifTrue: [
		cls _ self fromSexp: (from at: uniId asSymbol) from: from to: to.
		to addClass: cls.
		(obj _ self findIdref: idref context: to) ifNotNil: [^ obj].
		^ cls sissCreateInstanceFromSexp: sexp idref: idref from: from to: to.
	].
	sexp keyword == #slot ifTrue: [
		className _ sexp attributeAt: #class ifAbsent: [
			^ self fromSexp: (from at: idref) from: from to: to.
		].
	] ifFalse: [
		className _ sexp keyword.
	].
	classObj _ self classFromClassName: className.
	(uniId ~= '' and: [meta = 'true']) ifTrue: [
		classObj _ self uniclassUnder: classObj fromSexp: sexp from: from to: to.
		to addClass: classObj.
		^ classObj
	].
	to addClass: classObj.
	^ classObj sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/4/2007 01:42'!
idrefFromSexp: sexp

	sexp attributeAt: #idref ifPresent: [:idref | ^ idref asSymbol].
	^ nil.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 4/3/2007 11:06'!
sissBasicInstVarNamed: varName put: childInst in: context

	context sissInstVarNamed: varName put: childInst of: self.! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/3/2007 20:04'!
sissBitsInto: sexp context: dictionary

	self class isBytes ifTrue: [
		self sissBytesInto: sexp context: dictionary.
		^ self.
	] ifFalse: [
		self sissWordsInto: sexp context: dictionary.
		^ self.
	].
	self error: 'error'.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/23/2007 21:29'!
sissBytesInto: sexp context: dictionary

	| elementsString |
	
	elementsString _ (Base64MimeConverter mimeEncode: self readStream) contents.
	sexp attributeAt: #value put: elementsString.
	sexp attributeAt: #basicSize put: self size printString.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/9/2007 10:42'!
sissChildrenInto: newElem context: dictionary

	self class isBits ifTrue: [
		self sissBitsInto: newElem context: dictionary.
		^ self.
	].
		
	self sissWithCollectionEntries ifTrue: [
		self sissMixedFieldsInto: newElem context: dictionary.
		^ self.
	].
	self sissInstVarsInto: newElem context: dictionary.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/16/2007 00:25'!
sissComeFullyUpOnReloadFrom: from to: to

	"Override if you like"
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 19:16'!
sissContentsInto: newElem context: dictionary
	"Override if you like"
	| info |
	info _ self sissExportSpecification.
	info size > 0 ifTrue: [
		self sissSpecification: info into: newElem context: dictionary.
		^ self.
	].
	self sissChildrenInto: newElem context: dictionary! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:04'!
sissElementInContext: dictionary

	self sissIsLiteral ifTrue: [
		^ self sissStoreString
	].

	^ dictionary at: self ifNew: [:newElem |
		self sissWriteValue sissContentsInto: newElem context: dictionary
	].
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 19:15'!
sissExportSpecification
	"Override if you like.
	If the size of the returned array is larger than zero, only the information specified this array is written out.  The returned array is an array of pairs, and the first element of each pair specifies the information name and the second specifies the selector name to get the value."
	^ #().
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 12:13'!
sissIgnoreInstVarNames
	"Override if you like"
	^ #().
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/3/2007 21:36'!
sissIndexFieldsInto: sexp context: dictionary

	self sissWithBasicAt ifTrue: [
		^ self sissIndexFieldsWithBasicAtInto: sexp context: dictionary
	] ifFalse: [
		^ self sissIndexFieldsWithDoInto: sexp context: dictionary
	].
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:53'!
sissIndexFieldsWithBasicAtInto: sexp context: dictionary

	| child result elem |
	result _ WriteStream on: (Array new: self basicSize).
	1 to: self basicSize do: [:ind |
		elem _ self basicAt: ind.
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: ind printString).
		].
	].
	sexp attributeAt: #basicSize put: self basicSize printString.
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:52'!
sissIndexFieldsWithDoInto: sexp context: dictionary

	| ind child result |
	ind _ 0.
	result _ WriteStream on: (Array new: self size).
	self do: [:elem |
		ind := ind + 1.
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: ind printString).
		].
	].
	sexp attributeAt: #size put: self size printString.
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-interface' stamp: 'jl 9/21/2016 13:28'!
sissInitializeFrom: sexp from: from to: to
	"override if you like"
	| varName childInst |
	sexp elements do: [:elem |
		varName _ elem attributeAt: #name ifAbsent: [].
		childInst _ [self fromSexp: elem from: from to: to] on: Error do: [:e | 
		self inform: ('could not restore instance variable {1}, we hope for the best' translated format: {varName}).	
		].
		self sissInstVarNamed: varName put: childInst in: to
	].
! !

!Object methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:45'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:54'!
sissInstVarsInto: sexp context: dictionary

	| instVars ind child elem ignore result |
	instVars := self class allInstVarNames.
	ind := 0.
	ignore _ self sissIgnoreInstVarNames.
	result _ WriteStream on: (Array new: instVars size).
	instVars do: [:nm |
		ind := ind + 1.
		(ignore includes: nm) ifFalse: [
			elem _ self instVarAt: ind.
		] ifTrue: [
			elem _ nil
		].
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: nm).
		].
	].
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ false.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:45'!
sissMakeSlotSexpFor: elem child: child name: name

	| attrs |
	attrs _ WriteStream on: (SExpAttributes new: 3).
	child isString ifTrue: [
		attrs nextPut: (#class->elem class asString).
		attrs nextPut: (#value->child).
	] ifFalse: [
		attrs nextPut: (#idref->child idref).
	].
	attrs nextPut: (#name->name).
	^ SExpElement keyword: #slot attributes: attrs contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/2/2007 17:39'!
sissMixedFieldsInto: sexp context: dictionary
	self sissInstVarsInto: sexp context: dictionary.
	self sissIndexFieldsInto: sexp context: dictionary.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 15:27'!
sissScanObjects

	| dict |
	dict _ SISSDictionaryForScanning new initialize.

	^ dict sissScanObjectsFrom: self.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 11/8/2007 15:26'!
sissScanObjectsWithDict: dict

	^ dict sissScanObjectsFrom: self.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:01'!
sissSlotsFromSexp: sexp from: from to: to

	| dict |
	dict _ IdentityDictionary new.
	sexp elements do: [:e |
		e keyword == #slot ifTrue: [
			dict at: (e attributeAt: #name) asSymbol put: (self fromSexp: e from: from to: to)
		]
	].
	^ dict.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:55'!
sissSpecification: pairs into: sexp context: dictionary

	| child elem result |
	result _ WriteStream on: (Array new: pairs size).
	pairs do: [:pair |
		child _ (elem _ self perform: pair second)
			ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: pair first).
		].
	].
	sexp addElements: result contents.
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:28'!
sissStoreString

	^ self storeString.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 15:20'!
sissWithBasicAt

	^ true.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 15:57'!
sissWithCollectionEntries

	^ self class isVariable
! !

!Object methodsFor: '*siss-private' stamp: 'yo 3/23/2007 21:30'!
sissWordsInto: sexp context: dictionary

	| elementsString w |

	w _ WriteStream on: (ByteArray new: self basicSize*4+4).
	self writeOn: w.
	elementsString _ (Base64MimeConverter mimeEncode: w contents readStream) contents.
	sexp attributeAt: #value put: elementsString.
	sexp attributeAt: #basicSize put: self size printString.
! !

!Object methodsFor: '*siss-interface' stamp: 'yo 3/4/2007 03:41'!
sissWriteValue
	"Override if you wish"

	^self! !

!Object methodsFor: '*siss-private' stamp: 'yo 2/27/2008 15:03'!
uniclassUnder: officialClass fromSexp: sexp from: from to: to

	| idref obj className p slotsString exemplar dict pool poolString sup |
	idref := self idrefFromSexp: sexp.
	(obj _ self findIdref: idref context: to) ifNotNil: [^ obj].

	sexp attributeAt: #exemplar ifPresent: [:ex |
		exemplar _ self fromSexp: (from at: ex asSymbol) from: from to: to.
		(obj _ self findIdref: idref context: to) ifNotNil: [p _ obj] ifNil: [
			officialClass = KedamaSequenceExecutionStub ifTrue: [
				p _ exemplar class createSequencialStubSubclass.
			].
			officialClass = KedamaTurtleVectorPlayer2 ifTrue: [
				p _ exemplar class createTurtleSubclass2.
			].
		].
	].

	p ifNil: [
		sup _ sexp elements detect: [:e | e keyword = #slot and: [(e attributeAt: #name ifAbsent: ['']) = 'superclass']] ifNone: [nil].
		sup ifNotNil: [sup _ self fromSexp: (from at: sup idref asSymbol) from: from to: to].
		className _ (sup ifNil: [officialClass]) chooseUniqueClassName.
		slotsString _ sexp attributeAt: #slotsString ifAbsent: [''].
		poolString _ sexp attributeAt: #poolString ifAbsent: [''].
		p _ (sup ifNil: [officialClass ]) subclass: className instanceVariableNames: slotsString 
			classVariableNames: poolString poolDictionaries: '' category: officialClass categoryForUniclasses.
		"subclasses _ dict at: #subclasses ifAbsent: [#()].
		subclasses do: [:sub | p addSubclass: sub]."
		
	].
	idref ifNotNil: [to at: idref put: p].
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	pool _ dict at: #classPool ifAbsent: [#()].
	pool associationsDo: [:e | p classPool at: e key put: e value].

	to addClass: p.
	officialClass == Player ifTrue: [
		slotsString substrings do: [:inst |
			p compileAccessorsFor: inst
		].
	].

	(dict at: #methods ifAbsent: [#()]) do: [:pair | p compile: pair second classified: pair first].
	p sissInitializeFrom: sexp from: from to: to.

	^ p.
! !

Object subclass: #SExpElement
	instanceVariableNames: 'keyword attributes elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Meta'!

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/2/2007 23:17'!
keyword: n

	^ self new keyword: n; newAttributes.! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 20:39'!
keyword: n attributes: a

	^ self new keyword: n attributes: a.! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 22:48'!
keyword: n attributes: a elements: e

	^ self new keyword: n attributes: a elements: e.! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 20:22'!
keyword: n components: c

	| inst elem attrs |
	inst _ self new.
	"dict _ IdentityDictionary new."
	attrs _ WriteStream on: (SExpAttributes new: c size).
	elem _ OrderedCollection new: c size.
	c do: [:e |
		(e isMemberOf: Association) ifTrue: [
			attrs nextPut: e.
			"dict at: e key value put: e value value"
		] ifFalse: [
			elem addLast: e.
		].
	].
	^ inst keyword: n value attributes: attrs contents elements: elem asArray.! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 20:42'!
keyword: n elements: e

	^ self new keyword: n elements: e.! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/23/2007 20:34'!
addAttributes: assocs

	(attributes isNil or: [attributes isEmpty]) ifTrue: [
		attributes _ assocs.
	] ifFalse: [
		attributes _ attributes, assocs.
	].


	attributes _ attributes, assocs.
"
	assocs do: [:assoc |
		attributes at: assoc key put: assoc value.
	].
"! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/5/2007 12:45'!
addElements: aCollection

	elements ifNil: [
		elements _ aCollection.
	] ifNotNil: [
		elements _ elements, aCollection.
	].! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 2/28/2007 17:25'!
attributeAt: aSymbol

	^ attributes at: aSymbol.! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 2/28/2007 17:25'!
attributeAt: aSymbol ifAbsent: aBlock

	^ attributes at: aSymbol ifAbsent: aBlock.! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 2/28/2007 17:25'!
attributeAt: aSymbol ifPresent: aBlock

	^ attributes at: aSymbol ifPresent: aBlock.! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/22/2007 22:24'!
attributeAt: aSymbol ifPresent: aBlock ifAbsent: absentBlock

	^ (attributes at: aSymbol ifPresent: aBlock) ifNil: [^ absentBlock value].! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/23/2007 19:15'!
attributeAt: aSymbol put: aString

	^ attributes _ attributes copyWith: (aSymbol->aString).
"
	^ attributes at: aSymbol put: aString
"! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/22/2007 21:57'!
attributes

	^ IdentityDictionary new addAll: attributes; yourself.! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:28'!
elements

	^ elements.! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:28'!
elements: aCollection

	elements _ aCollection.! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 3/5/2007 10:57'!
elementsDo: aBlock

	elements ifNil: [^ self].
	elements do: aBlock.! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/21/2007 23:14'!
hasAttribute: attr

	^ attributes includesKey: attr.! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 3/2/2007 17:51'!
idref

	^ attributes at: #idref ifAbsent: [self error: 'should not happen'].! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 3/5/2007 11:06'!
idref: aString

	^ attributes at: #idref put: aString.! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:26'!
keyword

	^ keyword.! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:26'!
keyword: aSymbol

	keyword _ aSymbol.! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/23/2007 20:39'!
keyword: n attributes: a

	keyword _ n.
	attributes _ a.
	elements _ #().! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/2/2007 17:27'!
keyword: n attributes: a elements: e

	keyword _ n.
	attributes _ a.
	elements _ e.! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/23/2007 20:43'!
keyword: n elements: e

	keyword _ n.
	elements _ e.! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/23/2007 19:01'!
newAttributes

	attributes _ SExpAttributes new.

"
	attributes _ IdentityDictionary new.
"! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/5/2007 17:12'!
prettyPrintOn: aStream

	self prettyPrintOn: aStream indent: 0.! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/22/2007 21:59'!
prettyPrintOn: aStream indent: tabLevel

	aStream tab: tabLevel.
	aStream nextPutAll: '('.
	aStream nextPutAll: keyword.

	attributes notNil ifTrue: [
		attributes associations size > 0 ifTrue: [aStream space].
		attributes associations do: [:assoc |
			aStream nextPut: $:.
			aStream nextPutAll: assoc key.
			aStream space.
			aStream nextPut: $".
			aStream nextPutAll: assoc value sissEscape.
			aStream nextPut: $".
		] separatedBy: [aStream space].
	].

	(elements notNil and: [elements size > 0]) ifTrue: [
		elements do: [:each |
			aStream cr.
			each prettyPrintOn: aStream indent: tabLevel+1.
		].
	].

	aStream nextPutAll: ')'.! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/22/2007 21:59'!
prettyPrintOn: aStream indent: tabLevel sort: sortBlock

	aStream tab: tabLevel.
	aStream nextPutAll: '('.
	aStream nextPutAll: keyword.

	attributes notNil ifTrue: [
		attributes associations size > 0 ifTrue: [aStream space].
		attributes associations do: [:assoc |
			aStream nextPut: $:.
			aStream nextPutAll: assoc key.
			aStream space.
			aStream nextPut: $".
			aStream nextPutAll: assoc value sissEscape.
			aStream nextPut: $".
		] separatedBy: [aStream space].
	].

	(elements notNil and: [elements size > 0]) ifTrue: [
		(elements asSortedCollection: sortBlock) do: [:each |
			aStream cr.
			each prettyPrintOn: aStream indent: tabLevel+1.
		].
	].

	aStream nextPutAll: ')'.! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/20/2007 21:47'!
prettyPrintOn: aStream sort: sortBlock

	self prettyPrintOn: aStream indent: 0 sort: sortBlock.! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/5/2007 17:14'!
prettyString

	| w |
	w _ WriteStream on: (String new: 1000).
	self prettyPrintOn: w indent: 0.
	^ w contents.! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/20/2007 21:48'!
prettyStringWithSorting

	| w |
	w _ WriteStream on: (String new: 1000).
	self prettyPrintOn: w indent: 0 sort: [:a :b | a idref asNumber < b idref asNumber].
	^ w contents.! !

!SExpElement methodsFor: 'printing' stamp: 'tfel 8/11/2016 09:36'!
printOn: aStream

	aStream nextPutAll: '('.
	aStream nextPutAll: keyword.
	aStream space.

	attributes notNil ifTrue: [
		attributes associations do: [:assoc |
			aStream nextPut: $:.
			aStream nextPutAll: assoc key.
			aStream space.
			aStream nextPut: $".
			aStream nextPutAll: assoc value asString sissEscape.
			aStream nextPut: $".
		] separatedBy: [aStream space].
	].

	(elements notNil and: [elements size > 0]) ifTrue: [
		aStream space.
		elements do: [:each |
			each printOn: aStream.
		] separatedBy: [aStream space].
	].

	aStream nextPutAll: ')'.! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 4/5/2007 22:08'!
sissReadObjects

	^ self sissReadObjectsAsEtoysProject: false.! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 4/5/2007 22:08'!
sissReadObjectsAsEtoysProject

	^ self sissReadObjectsAsEtoysProject: true.! !

!SExpElement methodsFor: 'serialization specific' stamp: 'tfel 8/9/2016 15:30'!
sissReadObjectsAsEtoysProject: aBoolean

	| to from root ret w sel |
	to _ SISSDictionaryForReading new initialize.
	from _ IdentityDictionary new.
	(elements isNil or: [elements isEmpty]) ifTrue: [
		^ self fromSexp: self from: from to: to.
	].

	root _ self attributeAt: #root.
	elements do: [:e |
		e attributeAt: #idref ifPresent: [:id |
			from at: id asSymbol put: e
		].
	].

	w _ elements detect: [:e | (e attributeAt: #idref ifAbsent: []) = root].
	ret _ self fromSexp: w from: from to: to.
	from do: [:v | (v keyword = #SISSProxy) ifTrue: [
		sel _ (v attributeAt: #selector) asSymbol.
		(SISSProxy class methodDict includesKey: sel) ifTrue: [
			to at: v idref asSymbol put: (SISSProxy perform: sel)]]].
	to do: [:e | e sissComeFullyUpOnReloadFrom: from to: to].
	^ ret.! !

Object subclass: #SISSProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSProxy class methodsFor: 'as yet unclassified' stamp: 'yo 11/8/2007 16:31'!
worldPlayer

	^ ActiveWorld assuredPlayer.
! !

IdentityDictionary subclass: #SISSDictionaryForReading
	instanceVariableNames: 'nullDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSDictionaryForReading methodsFor: 'as yet unclassified' stamp: 'yo 4/3/2007 10:49'!
addClass: aClass

	| d |
	self at: aClass ifAbsentPut: [
		d _ Dictionary new: aClass allInstVarNames size.
		aClass allInstVarNames doWithIndex: [:e :i | d at: e put: i].
		d.
	].
! !

!SISSDictionaryForReading methodsFor: 'as yet unclassified' stamp: 'yo 4/3/2007 10:26'!
initialize

	nullDict _ Dictionary new: 0.
! !

!SISSDictionaryForReading methodsFor: 'as yet unclassified' stamp: 'yo 5/2/2007 23:23'!
sissInstVarNamed: iVar put: val of: anObject

	| ind |
	(anObject isBehavior and: [anObject isUniClass]) ifTrue: [
		ind _ anObject officialClass class allInstVarNames indexOf: iVar.
	] ifFalse: [
		ind _ (self at: anObject class ifAbsent: [nullDict]) at: iVar ifAbsent: [0].
	].
	ind > 0 ifTrue: [
		anObject instVarAt: ind put: val.
	] ifFalse: [
		" ask the class how to handle it..."
	].
! !

IdentityDictionary subclass: #SISSDictionaryForScanning
	instanceVariableNames: 'boundaryObjects'
	classVariableNames: 'PublishInSexp ReduceFormDepth'
	poolDictionaries: ''
	category: 'SISS-Core'!

SISSDictionaryForScanning subclass: #SISSDictionaryForGuideBook
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSDictionaryForGuideBook methodsFor: 'all' stamp: 'yo 2/20/2008 00:25'!
sissScanObjectsFrom: book

	| ret n child object |

	object _ (book pages copyWith: book color).

	ret _ object sissElementInContext: self.

	ret ifNil: [^ self sissScanObjectsFrom: nil].

	ret isString ifTrue: [
		"if object is just a literal, make up an element and return it."
		n _ SExpElement keyword: object class name.
		n attributeAt: #value put: ret.
		^ n
	].

	book world player ifNotNil: [self forceAdd: book world player].

	"Final fix up for scriptors."
	self keys do: [:e |
		(e isMemberOf: ScriptEditorMorph) ifTrue: [
			e playerScripted ifNotNil: [
				child _ e sexpScriptWith: self.
				(self at: e) addElements: (Array with: child).
			].
		]
	].
	^ self contents
! !

SISSDictionaryForScanning subclass: #SISSDictionaryForMorphCopying
	instanceVariableNames: 'allSubmorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Core'!

!SISSDictionaryForMorphCopying methodsFor: 'as yet unclassified' stamp: 'yo 5/2/2007 23:30'!
at: anObject ifNew: aBlock

	| newName newElem |
	(anObject isMorph and: [(allSubmorphs includes: anObject) not]) ifTrue: [^ nil].
	self at: anObject ifPresent: [:n | ^ n].
	newName _ (tally + 1) printString.
	newElem _ SExpElement keyword: (self headKeywordFor: anObject) attributes: (SExpAttributes with: #idref->newName).
	self at: anObject put: newElem.
	aBlock value: newElem.
	^ newElem.
! !

!SISSDictionaryForMorphCopying methodsFor: 'as yet unclassified' stamp: 'yo 5/2/2007 22:56'!
initializeSubmorphs: aMorph

	allSubmorphs _ IdentitySet new.
	aMorph allMorphsAndBookPagesInto: allSubmorphs
! !

!SISSDictionaryForScanning class methodsFor: 'instance creation' stamp: 'tfel 8/5/2016 16:43'!
new

	^ self basicNew initialize; initialize: 5; yourself! !

!SISSDictionaryForScanning class methodsFor: 'preferences' stamp: 'tfel 8/5/2016 17:16'!
publishInSexp

	<preference: 'Publish Projects as SISS Expressions'
		category: 'other'
		description: 'If true, projects are saved in Sexp form using SISS rather than as image segments'
		type: #Boolean>
	^ PublishInSexp ifNil: [PublishInSexp := true]! !

!SISSDictionaryForScanning class methodsFor: 'preferences' stamp: 'tfel 8/5/2016 17:16'!
publishInSexp: aBoolean

	^ PublishInSexp := aBoolean! !

!SISSDictionaryForScanning class methodsFor: 'accessing' stamp: 'yo 9/10/2007 10:42'!
reduceFormDepth

	^ ReduceFormDepth == true.
! !

!SISSDictionaryForScanning class methodsFor: 'accessing' stamp: 'yo 9/10/2007 14:14'!
reduceFormDepth: aBoolean

	ReduceFormDepth _ aBoolean.
! !

!SISSDictionaryForScanning class methodsFor: 'test' stamp: 'yo 3/7/2007 16:50'!
test1
"
	self test1
"
	| a b c d e f orig new |
	a _ Array new: 3.
	b _ #a.
	c _ 3.
	d _ $a.
	e _ Set with: a with: b with: c with: d.
	f _ {a. b. c. d. e}.

	#(Bag Array WeakArray OrderedCollection UrlArgumentList Set WeakSet) do: [:cls |
	orig _ (Smalltalk at: cls) withAll: f.
	new _ orig sissScanObjects sissReadObjects.
	self assert: [orig = new].
	].! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/23/2007 22:39'!
at: anObject ifNew: aBlock

	| newName newElem |
	(boundaryObjects includes: anObject) ifTrue: [^ nil].
	self at: anObject ifPresent: [:n | ^ n].
	newName _ (tally + 1) printString.
	newElem _ SExpElement keyword: (self headKeywordFor: anObject) attributes: (SExpAttributes with: #idref->newName).
	self at: anObject put: newElem.
	aBlock value: newElem.
	^ newElem.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/19/2007 14:02'!
boundaryObjects

	^ boundaryObjects
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/23/2007 22:46'!
contents

	| inst |
	inst _ SExpElement keyword: #objects attributes: (SExpAttributes with: #root->'1') elements: self values.
	^ inst.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 11/8/2007 16:13'!
forceAdd: anObject

	| newName newElem |
	(boundaryObjects includes: anObject) ifTrue: [^ nil].
	self at: anObject ifPresent: [:n | ^ n].
	newName _ (tally + 1) printString.
	newElem _ SExpElement keyword: #SISSProxy
				attributes: (SExpAttributes with: #idref->newName with: #selector->anObject sissProxySelector asString).
	self at: anObject put: newElem.
	^ newElem.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 3/26/2007 14:28'!
headKeywordFor: anObject

	anObject isBehavior ifTrue: [
		anObject isUniClass ifTrue: [^ anObject officialClass name].
		^ #Behavior
	].
	anObject class isUniClass ifTrue: [^ anObject class officialClass name].
	^ anObject class name.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'tfel 8/5/2016 16:41'!
initialize

	super initialize.
	boundaryObjects _ IdentitySet new.
! !

!SISSDictionaryForScanning methodsFor: 'all' stamp: 'yo 2/19/2008 11:47'!
sissScanObjectsFrom: object

	| ret n child |

	ret _ object sissElementInContext: self.

	ret ifNil: [^ self sissScanObjectsFrom: nil].

	ret isString ifTrue: [
		"if object is just a literal, make up an element and return it."
		n _ SExpElement keyword: object class name.
		n attributeAt: #value put: ret.
		^ n
	].

	"Final fix up for scriptors."
	self keys do: [:e |
		(e isMemberOf: ScriptEditorMorph) ifTrue: [
			e playerScripted ifNotNil: [
				child _ e sexpScriptWith: self.
				(self at: e) addElements: (Array with: child).
			].
		]
	].
	^ self contents
! !

!Metaclass class methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 15:01'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| dict |
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	^ (Smalltalk at: (dict at: #theNonMetaClassName) asSymbol) class.
! !

!Metaclass methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 14:57'!
sissExportSpecification

	^ #(('theNonMetaClassName' #theNonMetaClassName))
! !

!FunctionTile methodsFor: '*siss-interface' stamp: 'yo 9/7/2007 13:51'!
sexpWith: dictionary
	| n elements sel |
	sel _ submorphs first operatorOrExpression.
	n _ SExpElement keyword: #send.
	n attributeAt: #type put: ((owner isMemberOf: TilePadMorph) ifTrue: [owner type] ifFalse: ['Number']).
	elements _ Array with: ((SExpElement keyword: #selector)
					attributeAt: #selector put: sel; yourself)
				with: (argumentPad sexpWith: dictionary).
	n elements: elements.
	^ n.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 4/3/2007 12:45'!
assign: sexp

	| rcvr propertyName updating rhs p |
	rcvr _ self fromSexp: sexp elements first.

	propertyName _ sexp attributeAt: #property ifAbsent: [self error: ''].
	propertyName _ propertyName asSymbol.
	(#(patchValueIn: setRedComponentIn: setGreenComponentIn: setBlueComponentIn:) includes: propertyName) ifTrue: [
		^ self specialAssign: sexp with: rcvr.
	].

	updating _ sexp attributeAt: #updating ifAbsent: [nil].
	rhs _ self fromSexp: sexp elements last.

	p _ PhraseTileMorph new
		setAssignmentRoot: propertyName asSymbol
			type: #command
			rcvrType: #Player
			argType: (sexp attributeAt: #type ifAbsent: [#Number]) asSymbol
			vocabulary: self currentVocabulary.
	p justGrabbedFromViewer: false.
	updating ifNotNil: [p  submorphs second value: updating].
	p submorphs first addMorph: rcvr.
	p submorphs third setType: (sexp elements last attributeAt: #type ifAbsent: [#Number]) asSymbol.
	p submorphs third addMorph: rhs.
	(rhs resultType == #Number and: [rhs isMemberOf: TileMorph]) ifTrue: [
		rhs addSuffixArrow.
	].

	^ p.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 9/7/2007 15:37'!
condition: sexp

	| p testPart yesPart noPart n |
	testPart _ self fromSexp: (sexp elements first).
	yesPart _ self fromSexp: (sexp elements second).
	noPart _ self fromSexp: (sexp elements third).

	p _ CompoundTileMorph new.
	testPart = #() ifFalse: [
		p submorphs first submorphs last addNewRow addMorph: testPart.
	].

	yesPart do: [:e |
		n _ p submorphs second submorphs last addNewRow.
		n addMorph: e.
	].
	noPart do: [:e |
		n _ p submorphs third submorphs last addNewRow.
		n addMorph: e.
	].
	^ p.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 9/7/2007 14:08'!
functionSend: sexp with: rcvr with: realSel

	| p |
	p _ FunctionTile new.
	p operator: realSel pad: rcvr.
	^ p.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'sw 3/9/2012 00:26'!
literal: sexp
	"Answer an appropriate tile morph reconstituted from the s-expression provided."

	| type n lit s xComp yComp |
	type _ sexp attributeAt: #type ifAbsent: [].
	type ifNotNil: [type _ type asSymbol].
	(type == #Player or: [type == #Patch]) ifTrue: [
		n _ sexp attributeAt: #value ifAbsent: [].
		n ifNotNil: [
			n = 'self' ifTrue: [^ TileMorph new setToReferTo: playerScripted].
			n = 'nil' ifTrue: [^ TileMorph new setToReferTo: playerScripted presenter standardPlayer].
			^ TileMorph new setToReferTo: (context at: n asSymbol)
		].
		^ TileMorph new setToReferTo: World presenter standardPlayer
	].
	type == #String ifTrue: [
		lit _ sexp attributeAt: #value.
		^ (TileMorph new setLiteral: lit).
	].
	type == #Point ifTrue: [
		lit _ sexp attributeAt: #value.
		xComp _ lit copyFrom: 1 to: (lit indexOf: $@) - 1.
		yComp _ lit copyFrom: (lit indexOf: $@) + 1 to: lit size.
		
		lit _ xComp asNumber@yComp asNumber.
		^ (TileMorph new setLiteral: lit).
	].
	type == #Color ifTrue: [
		lit _ Color readFrom: (sexp attributeAt: #value).
		^ ColorTileMorph new colorSwatchColor: lit.
	].
	type == #Boolean ifTrue: [
		lit _ (sexp attributeAt: #value) = 'true'.
		^ TileMorph new addArrows; setLiteral: lit

	].
	type == #Sound ifTrue: [
		lit _ sexp attributeAt: #value.
		^ SoundTile new literal: lit.
	].
	type == #ScriptName ifTrue: [
		lit _ sexp attributeAt: #value.
		^ ScriptNameTile new literal: lit asSymbol.
	].

	(type == #Object or: [type == #Number]) ifTrue: [
		lit _ Number readFrom: (sexp attributeAt: #value).
		^ (TileMorph new setLiteral: lit)
				setDecimalPlacesFromTypeIn: (sexp attributeAt: #value);
				addArrows.
	].
	(type == #Graphic) ifTrue: [
		lit _ (context at: (sexp attributeAt: #value) asSymbol).
		^ (GraphicTile new setLiteral: lit).
	].
	(type == #Menu) ifTrue: [
		lit _ sexp attributeAt: #value.
		^ (MenuTile new setLiteral: lit).
	].

	((Vocabulary allStandardVocabularies select: [:m | m isKindOf: SymbolListType]) includesKey: type)
		ifTrue:
			[lit _ sexp attributeAt: #value.
			s _ SymbolListTile new.
			s choices: (Vocabulary allStandardVocabularies at: type) choices dataType: type.
			^ s setLiteral: lit asSymbol; addArrows]! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'sw 6/15/2007 18:16'!
loop: sexp
	"Answer a TimesRepeatTile derived from the s-expression provided."

	| p test body whatToRepeatPart numberOfTimesToRepeatPart |
	"You can think of different loops, but for current Etoys, there is only one kind."
	"initial _ sexp elements detect: [:e | e keyword == #initial] ifNone: [nil].
	increment _ sexp elements detect: [:e | e keyword == #increment] ifNone: [nil]."
	test _ sexp elements detect: [:e | e keyword == #test] ifNone: [nil].
	body _ sexp elements detect: [:e | e keyword == #sequence] ifNone: [nil].

	test _ self fromSexp: test elements first.

	body _ self fromSexp: body.
	p _ TimesRepeatTile new.
	numberOfTimesToRepeatPart _ p numberOfTimesToRepeatPart.
	numberOfTimesToRepeatPart removeAllMorphs; addMorph: test.
	whatToRepeatPart _ p instVarNamed: 'whatToRepeatPart'.
	body do: [:b |
		whatToRepeatPart addNewRow addMorph: b.
	].
	^ p.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 4/2/2007 16:03'!
phraseForSpecialKedamaSend: realSel

	realSel == #getPatchValueIn: ifTrue: [
		^ PhraseTileMorph new setGetPixelOperator: realSel type: #Number rcvrType: #Player argType: #Patch.
	].
	realSel == #getAngleTo: ifTrue: [
		^ PhraseTileMorph new setAngleToOperator: realSel type: #Number rcvrType: #Player argType: #Player.
	].
	realSel == #bounceOn: ifTrue: [
		^ PhraseTileMorph new setBounceOnOperator: realSel type: #Boolean rcvrType: #Player argType: #Player.
	].
	realSel == #getDistanceTo: ifTrue: [
		^ PhraseTileMorph new setDistanceToOperator: realSel type: #Number rcvrType: #Player argType: #Player
	].
	realSel == #getTurtleOf: ifTrue: [
		^ PhraseTileMorph new setTurtleOfOperator: realSel type: #Player rcvrType: #Player argType: #Player
	].
	realSel == #getUphillIn: ifTrue: [
		^ PhraseTileMorph new setUpHillOperator: realSel type: #Number rcvrType: #Player argType: #Player
	].
	realSel == #getRedComponentIn: ifTrue: [
		^ PhraseTileMorph new setGetColorComponentOperator: realSel componentName: #red type: #Number rcvrType: #Player argType: #Patch
	].
	realSel == #getGreenComponentIn: ifTrue: [
		^ PhraseTileMorph new setGetColorComponentOperator: realSel componentName: #green type: #Number rcvrType: #Player argType: #Patch
	].
	realSel == #getBlueComponentIn: ifTrue: [
		^ PhraseTileMorph new setGetColorComponentOperator: realSel componentName: #blue type: #Number rcvrType: #Player argType: #Patch
	].

	^ nil.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 4/3/2007 11:30'!
script: sexp

	| scriptName params entry morphs row isTiles code |
	scriptName _ (sexp attributeAt: #scriptName) asSymbol.
	params _ sexp elements select: [:e | e keyword == #parameter].

	entry _ playerScripted class permanentUserScriptFor: scriptName asSymbol player: playerScripted.

	params _ params collect: [:e | Variable new name: (e attributeAt: #name) asSymbol type: (e attributeAt: #type) asSymbol].
	entry argumentVariables: params.
	topEditor _ entry instantiatedScriptEditorForPlayer: playerScripted.

	isTiles _ (sexp attributeAt: #language ifAbsent: ['Squeak']) = 'Etoys'.
	isTiles ifTrue: [
		morphs _ self fromSexp: (sexp elements detect: [:e | e keyword == #sequence] ifNone: []).
		morphs do: [:e |
			row _ topEditor addNewRow.
			row addMorph: e.
		].
	] ifFalse: [
		code _ (sexp elements detect: [:e | e keyword == #code]) attributeAt: #value.
		playerScripted class compileSilently: code classified: 'scripts'.
		topEditor userScriptObject becomeTextuallyCoded.
		(topEditor submorphs copyFrom: 2 to: topEditor submorphs size) do: [:m | m delete].
		topEditor showSourceInScriptor.
	].

	^ entry.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 9/7/2007 14:02'!
send: sexp

	| rcvr type selNode realSel val p argType |
	rcvr _ self fromSexp: sexp elements second.
	type _ sexp attributeAt: #type ifAbsent: ['#Player'].
	selNode _ sexp elements first.
	realSel _ selNode attributeAt: #getter ifAbsent: [].
	realSel ifNotNil: [
		realSel _ Utilities getterSelectorFor: realSel.
		(rcvr isMemberOf: PhraseTileMorph) ifFalse: [rcvr bePossessive].
	] ifNil: [
		realSel _ (selNode attributeAt: #selector) asSymbol.
		"realSel ifNil: [self error: '']."
	].
	(#(getAngleTo: bounceOn: getDistanceTo: getPatchValueIn: getTurtleOf: getUphillIn: getRedComponentIn: getGreenComponentIn: getBlueComponentIn:) includes: realSel) ifTrue: [
		^ self specialKedamaSend: sexp with: rcvr with: realSel
	].
	(#(color:sees:) includes: realSel) ifTrue: [
		^ self specialSend: sexp with: rcvr with: realSel
	].
	((ScriptingSystem tableOfNumericFunctions collect: [:e | e second]) includes: realSel) ifTrue: [
		^ self functionSend: sexp with: rcvr with: realSel
	].

	p _ PhraseTileMorph new
			setOperator: realSel
				type: type asSymbol
				rcvrType: #Player
				argType: #Number.
	p justGrabbedFromViewer: false.
	p submorphs first addMorph: rcvr.
	p submorphs first setType: (sexp elements second attributeAt: #type ifAbsent: ['Number']) asSymbol.
	sexp elements size = 2 ifTrue: [
		(p resultType == #Number and: [p submorphs second isMemberOf: TileMorph]) ifTrue: [
			p submorphs second addSuffixArrow.
		].
	].
	sexp elements size > 2 ifTrue: [
		val _ self fromSexp: sexp elements third.
		argType _ (sexp elements third attributeAt: #type ifAbsent: ['Number']) asSymbol.
		p submorphs third setType: argType.
		p submorphs third addMorph: val.
		(argType == #Number and: [val isMemberOf: TileMorph]) ifTrue: [val addSuffixArrow.
			(#(#+ #- #* #/ #'//' #'\\' #max: #min: #< #'<=' #= #'~=' #> #'>=' #isDivisibleBy:) includes: realSel) ifFalse: [p submorphs second addRetractArrowAnyway].
		].
	].
	^ p.
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 4/2/2007 16:05'!
sequence: sexp

	^ sexp elements collect: [:elem |
		self fromSexp: elem.
	].
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 4/3/2007 12:46'!
specialAssign: sexp with: rcvr

	| propertyName updating rhs patch p componentName |
	propertyName _ (sexp attributeAt: #property) asSymbol.
	updating _ sexp attributeAt: #updating ifAbsent: [nil].
	rhs _ self fromSexp: sexp elements last.
	(propertyName == #patchValueIn:) ifTrue: [
		patch _ self fromSexp: sexp elements second.

		p _ PhraseTileMorph new
			setPixelValueRoot: propertyName asSymbol
				type: #command
				rcvrType: #Player
				argType: #Number
				vocabulary: self currentVocabulary.
		p justGrabbedFromViewer: false.
		updating ifNotNil: [p submorphs second value: updating].
		p submorphs first addMorph: rcvr.
		p submorphs third setType: (sexp elements last attributeAt: #type ifAbsent: [#Number]) asSymbol.
		p submorphs third addMorph: rhs.
		p submorphs second setPatchDefaultTo: patch actualObject.
		^ p.
	].
	(propertyName == #setRedComponentIn:) ifTrue: [componentName _ #red].
	(propertyName == #setGreenComponentIn:) ifTrue: [componentName _ #green].
	(propertyName == #setBlueComponentIn:) ifTrue: [componentName _ #blue].

	(#(setRedComponentIn: setGreenComponentIn: setBlueComponentIn:) includes: propertyName) ifTrue: [
		patch _ self fromSexp: sexp elements second.

		p _ PhraseTileMorph new
					setColorComponentRoot: propertyName
					componentName: componentName
					type: #command
					rcvrType: #Patch
					argType: #Number
					vocabulary: self currentVocabulary.
		p justGrabbedFromViewer: false.
		updating ifNotNil: [p submorphs second value: updating].
		p submorphs first addMorph: rcvr.
		p submorphs third setType: (sexp elements last attributeAt: #type ifAbsent: [#Number]) asSymbol.
		p submorphs third addMorph: rhs.
		p submorphs second setPatchDefaultTo: patch actualObject.
		^ p.
	].

! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 4/3/2007 12:45'!
specialKedamaSend: sexp with: rcvr with: realSel

	| p val |
	val _ self fromSexp: sexp elements third.
	p _ self phraseForSpecialKedamaSend: realSel.
	p justGrabbedFromViewer: false.
	p submorphs first addMorph: rcvr.
	p submorphs second setArgumentDefaultTo: val actualObject.
	^ p
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 9/7/2007 14:07'!
specialSend: sexp with: rcvr with: realSel

	| p val |
	sexp elements size > 2 ifTrue: [
		val _ self fromSexp: sexp elements third.
	].
	realSel == #color:sees: ifTrue: [
		p _  PhraseTileMorph new 
				setOperator: #+
				type: #Boolean
				rcvrType: #Player
				argType: #Color.	"temp dummy"
		p justGrabbedFromViewer: false.
		p submorphs first addMorph: rcvr.
		p submorphs second delete.
		p addMorph: (ColorSeerTile new showPalette: false; colorSwatchColor: (val colorSwatch color)) behind: p submorphs first.
		p submorphs last setType: (sexp elements fourth attributeAt: #type ifAbsent: ['Number']) asSymbol.
		p submorphs last addMorph: (self fromSexp: sexp elements fourth).
		^ p.
	].
! !

!ScriptEditorMorphBuilder methodsFor: '*siss-reconstituting scripting tiles ' stamp: 'yo 4/6/2007 15:15'!
variable: sexp

	| p |
	p _ ParameterTile new.
	p scriptEditor: topEditor.
	p line1: (sexp attributeAt: #type) translated.
	^ p.
! !

!Array class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:00'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

Array variableSubclass: #SExpAttributes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Meta'!

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/22/2007 21:58'!
associations

	^ self.! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 21:15'!
at: key

	^ self at: key ifAbsent: [self error: 'key not found'].! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 21:08'!
at: key ifAbsent: aBlock

	self do: [:assoc |
		assoc key == key ifTrue: [^ assoc value].
	].
	^ aBlock value.! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 21:08'!
at: key ifPresent: aBlock

	self do: [:assoc |
		assoc key == key ifTrue: [^ aBlock value: assoc value].
	].
	^ nil.! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:09'!
do: aBlock 

	1 to: self size do:
		[:index | aBlock value: (self basicAt: index)]! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:12'!
do: elementBlock separatedBy: separatorBlock

	1 to: self size do:
		[:index |
		index = 1 ifFalse: [separatorBlock value].
		elementBlock value: (self basicAt: index)]! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:08'!
includesKey: attr

	1 to: self size do: [:i |
		(self basicAt: i) key == attr ifTrue: [^ true].
	].
	^ false.! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:00'!
isNil

	^ (self size = 0).! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:01'!
notNil

	^ self isNil not.! !

!ByteSymbol class methodsFor: '*siss-instance creation' stamp: 'yo 3/9/2007 11:04'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst |
	inst _ (sexp attributeAt: #value).
	inst _ self intern: inst.
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

!ByteSymbol methodsFor: '*siss-interface' stamp: 'yo 3/9/2007 11:19'!
sissStoreString

	^ self asString.
! !

!Set methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context

	self sissWithCollectionEntries ifFalse: [
		^ self sissBasicInstVarNamed: varName put: childInst in: context
	] ifTrue: [
		self add: childInst
	].
! !

!Set methodsFor: '*siss-private' stamp: 'yo 3/5/2007 15:58'!
sissWithCollectionEntries

	^ true.
! !

!BookMorph class methodsFor: '*siss-instance creation' stamp: 'yo 9/17/2007 11:30'!
bookFromPagesInSISSFormat: sexp

	| pages book pagesAndColor color |
	pagesAndColor _ sexp sissReadObjects.
	pages _ pagesAndColor copyFrom: 1 to: pagesAndColor size - 1.
	color _ pagesAndColor last.
	book _ BookMorph new.
	pages do: [:p | p setProperty: #transitionSpec toValue: (Array with: 'silence' with: #none with: #none)].
	book pageControlsAtTop: false.
	book hidePageControls.
	book newPages: pages.
	book extent: pages first extent + (10@10).
	book color: color.
	book goToPage: 1.
	^ book.
! !

!BookMorph class methodsFor: '*siss-instance creation' stamp: 'tfel 9/23/2016 10:19'!
loadFromDataStreamNamed: zippedFileName
	| zipped unzipped f |
	unzipped := WriteStream on: ByteArray new.
	f := (FileStream readOnlyFileNamed: zippedFileName) binary.
	zipped := GZipReadStream on: f.
	unzipped nextPutAll: zipped contents.
	[ComplexProgressIndicator new 
		targetMorph: nil;
		historyCategory: 'book loading';
		withProgressDo: [
			^ self bookFromPagesInSISSFormat: (DataStream on: (ReadStream on: (unzipped contents))) next]] ensure: [f close].! !

!BookMorph methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 16:08'!
pagesAndColorInSISSFormat

	| dict |
	dict _ SISSDictionaryForGuideBook new initialize.
	self owner ifNotNil: [
		dict boundaryObjects add: self.
	].
	^ dict sissScanObjectsFrom: self.! !

!BookMorph methodsFor: '*siss-fileIn/out' stamp: 'yo 9/10/2007 15:13'!
storeAsDataStream

	self storeAsDataStreamNamed: Project current name, '.sexp.data.gz'.! !

!BookMorph methodsFor: '*siss-fileIn/out' stamp: 'yo 9/10/2007 15:44'!
storeAsDataStreamNamed: zippedFileName

	| f d bytes zipped |
	bytes := WriteStream on: ByteArray new.
	d := DataStream on: bytes.
	d nextPut: self pagesAndColorInSISSFormat.
	d close.
	f := FileStream newFileNamed: zippedFileName.
	f binary; setFileTypeToObject.
	zipped := GZipWriteStream on: f.
	zipped nextPutAll: bytes contents.
	zipped close.
	f close
! !

!Form methodsFor: '*siss-interface' stamp: 'yo 9/10/2007 10:42'!
sissWriteValue

	SISSDictionaryForScanning reduceFormDepth ifTrue: [
		^ (self asFormOfDepth: 8) hibernate.
	].
	^ self hibernate.
! !

!StrikeFont methodsFor: '*siss-private' stamp: 'yo 3/9/2007 13:45'!
sissStoreString

	^ self familyName, ' ', self height asString, ' ', self emphasis asString! !

!SystemWindow class methodsFor: '*siss-private' stamp: 'yo 2/20/2008 14:59'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| model w contents dict |

	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	model _ dict at: #model ifAbsent: [].

	model ifNotNil: [
		(model isMemberOf: Workspace) ifTrue: [
			model embeddedInMorphicWindowLabeled: (dict at: #label).
			model sissSetContents: model contents.
		].
		w _ model dependents detect: [:e | e isMemberOf: SystemWindow] ifNone: [nil].
		w privateOwner: (dict at: #owner).
		w ifNotNil: [
			w bounds: (dict at: #bounds).
			idref ifNotNil: [to at: idref put: w].
			^ w.
		].
	] ifNil: [
		contents _ dict at: #contents ifAbsent: [].
		w _ contents embedInWindow.
		w privateOwner: (dict at: #owner).
		w bounds: (self fromSexp: (sexp elements detect: [:e | e keyword = #slot and: [(e attributeAt: #name) = #bounds]]) from: from to: to).
		idref ifNotNil: [to at: idref put: w].
		^ w.
	].
	w _  SystemWindow new.
	w privateOwner: (dict at: #owner).
	idref ifNotNil: [to at: idref put: w].
	^ w.
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 20:47'!
contents

	^ self isCollapsed ifTrue: [nil] ifFalse: [submorphs second]
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 21:39'!
model

	^ model
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 3/19/2007 21:39'!
modelOrContent

	^ model
! !

!SystemWindow methodsFor: '*siss-interface' stamp: 'yo 2/20/2008 14:34'!
sissExportSpecification

	^ #(('bounds' #bounds)
		('owner' #owner)
		('label' #label)
		('model' #model)
	)
! !

!TTCFont class methodsFor: '*siss-instance creation' stamp: 'yo 12/7/2007 15:41'!
familyName: aName size: aSize emphasized: emphasisCode

	^ self familyName: aName pointSize: aSize emphasized: emphasisCode! !

!TileMorph methodsFor: '*siss-interface' stamp: 'yo 4/1/2007 16:17'!
sexpWith: dictionary
	"Store code representing the receiver onto the stream, with the given amount of indentation"

	| playerBearingCode ownerType n p |
	playerBearingCode := self playerBearingCode.	"Must determine whom is scripted for what follows to work; if it's ever nil, we've got trouble"
	type = #expression 
		ifTrue: 
			[^ (SExpElement keyword: #code) attributeAt: #value put: operatorOrExpression; yourself]. 
	type = #literal 
		ifTrue: 
			[n _ SExpElement keyword: #literal.
			(self owner isMemberOf: TilePadMorph) ifTrue: [
				n attributeAt: #type put: (ownerType _ owner type).
			] ifFalse: [
				n attributeAt: #type put: 'Number'
			].
			ownerType = #Graphic ifTrue: [
				n attributeAt: #value put: (dictionary at: literal).
			] ifFalse: [
				ownerType = #String ifTrue: [
					n attributeAt: #value put: literal.
				] ifFalse: [
					n attributeAt: #value put: literal asString.
				].
			].
			^ n.
		].

	type == #objRef 
		ifTrue: 
			[^playerBearingCode == actualObject 
				ifTrue: 
					["If the object is the method's own 'self' then we MUST, rather than just MAY, put out 'self' rather than the referencer call, though the latter will temporarily work if only one instance of the uniclass exists."

					n _ SExpElement keyword: #literal.
					n attributeAt: #type put: 'Player'.
					n attributeAt: #value put: 'self'.
					^ n.
				] ifFalse: [
					(actualObject isPlayerLike and: [actualObject isSequentialStub]) ifTrue: [
						^ actualObject sexpWith: dictionary.
					] ifFalse: [
						n _ SExpElement keyword: #literal.
						n attributeAt: #type put: ((actualObject costume isMemberOf: KedamaPatchMorph) ifTrue: ['Patch'] ifFalse: ['Player']).
						p _ dictionary at: actualObject ifAbsent: [].
						n attributeAt: #value put: (p ifNotNil: [p idref] ifNil: ['nil']).
						^ n]]].
! !

!AssignmentTileMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 12:36'!
sexpWith: dictionary

	self error: 'error'.

! !

!SystemVersion class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:07'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ Current.

"
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	((Current date = (dict at: #date))
		and: [(Current version = (dict at: #version))
			and: [(Current hightestUpdate = (dict at: #hightestUpdate))]]) ifTrue: [
	].
"! !

!SystemVersion methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:08'!
sissContentsInto: newElem context: dictionary
! !

!ColorTileMorph methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:48'!
sexpWith: dictionary

	^ SExpElement keyword: #literal attributes: (SExpAttributes with: #value->colorSwatch color printString with: #type->'Color').
! !

!Point class methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:24'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	"super sissCreateInstanceFromSexp: sexp idref: idref from: from to: to"
	| value ind x y |
	value _ (sexp attributeAt: #value).
	value first = $( ifTrue: [value := value allButFirst allButLast].
	ind := value indexOf: $@.
	x := (value copyFrom: 1 to: (ind - 1)) withBlanksTrimmed asNumber.
	y := (value copyFrom: ind + 1 to: value size) withBlanksTrimmed asNumber.
	^ x@y.
! !

!Point methodsFor: '*siss-private' stamp: 'yo 3/20/2007 21:54'!
sissIsLiteral

	^ true.
! !

!BlockContext class methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 14:06'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| ret |
	ret _ Compiler evaluate: (sexp attributeAt: #value) for: nil logged: false.
	idref ifNotNil: [to at: idref put: ret].
	^ ret.
! !

!BlockContext methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 14:07'!
sissIsLiteral

	^ true.
! !

!BlockContext methodsFor: '*siss-interface' stamp: 'yo 4/3/2007 14:04'!
sissStoreString

	| node |
	node _ self decompile.
	^ (DialectStream dialect: #ST80 contents: [:strm | node printOn: strm indent: 0]) asString
! !

!Behavior class methodsFor: '*siss-interface' stamp: 'yo 3/21/2007 23:20'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| c |
	c _ Smalltalk at: (sexp attributeAt: #value) asSymbol.
	(sexp hasAttribute: #metaclass) ifTrue: [
		^ c class.
	].
	^ c.
! !

!Behavior methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:59'!
sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| inst |
	inst _ self sissNew: self withSexp: sexp.
	idref ifNotNil: [to at: idref put: inst].
	inst sissInitializeFrom: sexp from: from to: to.
	^ inst.
! !

!Behavior methodsFor: '*siss-instance creation' stamp: 'yo 2/27/2008 15:21'!
sissContentsInto: newElem context: dictionary

	self isUniClass ifTrue: [
		super sissContentsInto: newElem context: dictionary.
		newElem attributeAt: #uniclass put: newElem idref.
	].
	self class = Metaclass ifTrue: [
		newElem attributeAt: #metaclass put: 'true'.
		self theNonMetaclass isUniClass ifTrue: [
			newElem attributeAt: #uniclass put: newElem idref.
		].
	] ifFalse: [
		self isUniClass ifFalse: [
			newElem attributeAt: #value put: self name.]
	].
! !

!Behavior methodsFor: '*siss-instance creation' stamp: 'yo 3/21/2007 23:13'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	"override if you like"
	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Behavior methodsFor: '*siss-private' stamp: 'yo 3/4/2007 01:47'!
sissNew: aClass withSexp: sexp

	sexp attributeAt: #basicSize ifPresent: [:basicSize |
		^ aClass basicNew: (Integer readFromString: basicSize).
	].
	sexp attributeAt: #size ifPresent: [:size |
		^ aClass new: (Integer readFromString: size).
	].
	^ aClass basicNew.
! !

!ArrayedCollection class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst |
	inst _ self newFromStream: (Base64MimeConverter mimeDecodeToBytes: (sexp attributeAt: #value) readStream) reset.
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

!ArrayedCollection methodsFor: '*siss-private' stamp: 'yo 3/4/2007 03:53'!
sissInstVarNamed: varName put: childInst

	self sissWithBasicAt ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self at: varName asInteger put: childInst
	].
! !

!ArrayedCollection methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:45'!
sissInstVarNamed: varName put: childInst in: context

	self sissWithBasicAt ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self at: varName asInteger put: childInst
	].
! !

!ArrayedCollection methodsFor: '*siss-private' stamp: 'yo 3/3/2007 21:39'!
sissWithBasicAt

	^ true.
! !

!Float class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst str |
	
	str _ (Base64MimeConverter mimeDecodeToBytes: (sexp attributeAt: #value) readStream) reset.
	inst _ Float basicNew: 2.
	inst basicAt: 1 put: (str nextNumber: 4).
	inst basicAt: 2 put: (str nextNumber: 4).
	^ inst.
! !

!Float methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:27'!
sissStoreString

	| w |
	w _ WriteStream on: (ByteArray new: self size*4).
	self writeOn: w.
	^ (Base64MimeConverter mimeEncode: w contents readStream) contents.
! !

!Float methodsFor: '*siss-private' stamp: 'yo 3/4/2007 21:50'!
writeOn: aStream
	aStream nextWordsPutAll: self.! !

!PhraseTileMorph methodsFor: '*siss-interface' stamp: 'yo 4/1/2007 14:41'!
sexpAssignmentWith: dictionary

	| suffix n elements |
	n _ SExpElement keyword: #assign.

	(submorphs third isMemberOf: TilePadMorph) ifTrue: [
		n attributeAt: #type put: submorphs third type.
	].
	
	suffix _ submorphs second operatorForSexpAssignmentSuffix: submorphs second assignmentSuffix.
	suffix isEmpty ifFalse: [
		n attributeAt: #updating put: suffix.
	].

	n attributeAt: #property put: (submorphs second assignmentRoot).

	elements _ WriteStream on: (Array new: 3).
	elements nextPut: (submorphs first sexpWith: dictionary).
	(submorphs second isMemberOf: AssignmentTileMorph) ifFalse: [
		elements nextPut: (submorphs second sexpWith: dictionary).
	].
	elements nextPut: (submorphs third sexpWith: dictionary).
	n elements: elements contents.
	^ n.
! !

!PhraseTileMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 12:54'!
sexpColorSeerWith: dictionary

	| n elements |
	n _ SExpElement keyword: #send.
	n attributeAt: #type put: 'Boolean'.
	elements _ OrderedCollection new: 3.
	elements add: ((SExpElement keyword: #selector) attributeAt: #selector put: 'color:sees:'; yourself).
	elements add: (submorphs first sexpWith: dictionary).
	elements add: ((SExpElement keyword: #literal)
				attributeAt: #type put: 'Color';
				attributeAt: #value put: submorphs second colorSwatch color printString;
				yourself).
	elements add: (submorphs third sexpWith: dictionary).
	n elements: elements asArray.
	^ n.
! !

!PhraseTileMorph methodsFor: '*siss-interface' stamp: 'yo 9/7/2007 15:42'!
sexpOperatorWith: dictionary

	| op n elements sel |
	n _ SExpElement keyword: #send.

	op _ submorphs second operatorOrExpression.
	(self owner isKindOf: TilePadMorph) ifTrue: [
		n attributeAt: #type put: owner type.
	] ifFalse: [
		(#(< > = <= >= ~= isDivisibleBy:) includes: op) ifTrue: [
			"op _ (TileMorph classPool at: #EqualityOperators) at: op ifAbsent: [op]."
			n attributeAt: #type put: 'Boolean'.
		] ifFalse: [
			n attributeAt: #type put: 'unknown'.  "this had some scary consequence".
		].
	].

	elements _ OrderedCollection new: 3.
	sel _ SExpElement keyword: #selector.
	(self isGetter: op) ifTrue: [
		sel attributeAt: #getter put: (Utilities inherentSelectorForGetter: op).
	] ifFalse: [
		sel attributeAt: #selector put: op.
	].
	elements add: sel.
	elements add: (submorphs first sexpWith: dictionary).

	((submorphs second isMemberOf: TileCommandWithArgumentMorph) or: [
		 submorphs second isMemberOf: KedamaGetColorComponentTile]) ifTrue: [
		elements add: (submorphs second sexpWith: dictionary)
	].

	(3 to: submorphs size) do: [:e |
		elements add: ((submorphs at: e) sexpWith: dictionary).
	].
	n elements: elements asArray.
	^ n.
! !

!PhraseTileMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 12:55'!
sexpWith: dictionary

	submorphs size >= 2 ifTrue: [
		self isAssignment ifTrue: [
			^ self sexpAssignmentWith: dictionary
		].
		self isColorSeer ifTrue: [
			^ self sexpColorSeerWith: dictionary
		].
		(true) ifTrue: [
			^ self sexpOperatorWith: dictionary
		].
	].
	^ submorphs first sexpWith: dictionary.
! !

!MethodNode methodsFor: '*siss-interface' stamp: 'yo 9/11/2007 14:56'!
sexpWith: aDictionary obj: obj

	| elems n pSexp tmp tmps |

	elems _ WriteStream on: (Array new: arguments size + 1).
	n _ SExpElement keyword: #slot.
	n attributeAt: #name put: 'script'.
	n attributeAt: #scriptName put: (selectorOrFalse isSymbol ifTrue: [selectorOrFalse] ifFalse: [selectorOrFalse key]).
	n attributeAt: #language put: 'Squeak'.

	pSexp _ aDictionary at: encoder classEncoding ifAbsent: [].
	n attributeAt: #playerClass put: (pSexp ifNotNil: [pSexp idref] ifNil: ['0']).

	1 to: arguments size do: [:i |
		elems nextPut: ((SExpElement keyword: #parameter)
							attributeAt: #position put: i printString;
							attributeAt: #name put: (arguments at: i) key; yourself).
	].

	temporaries size > 0 ifTrue: [
		tmp _ SExpElement keyword: #temporary.
		tmps _ WriteStream on: Array new.
		temporaries do: [:e |
			tmps nextPut: (e sexpWith: aDictionary obj: obj).
		].
		tmp elements: tmps contents.
		elems nextPut: tmp.
	].

	elems nextPut: (block sexpWith: aDictionary obj: obj).

	n addElements: elems contents.
	^ n.
! !

!KedamaSetPixelValueTile methodsFor: '*siss-interface' stamp: 'yo 4/1/2007 14:41'!
sexpWith: aDictionary

	^ patchTile sexpWith: aDictionary.
! !

!Rectangle class methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 11:54'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	"super sissCreateInstanceFromSexp: sexp idref: idref from: from to: to"
	| value ind indSpace origX origY cornerX cornerY |
	value := (sexp attributeAt: #value).
	value first = $( ifTrue: [value := value allButFirst allButLast].
	ind := value indexOf: $@.
	indSpace := value indexOf: Character space startingAt: ind+2.
	origX := (value copyFrom: 1 to: (ind - 1)) withBlanksTrimmed asNumber.
	origY := (value copyFrom: ind + 1 to: indSpace-1) withBlanksTrimmed asNumber.
	indSpace := value indexOf: Character space startingAt: indSpace+1.
	ind := value indexOf: $@ startingAt: indSpace+1.
	cornerX := (value copyFrom: indSpace+1 to: (ind - 1)) withBlanksTrimmed asNumber.
	cornerY := (value copyFrom: ind + 1 to: value size) withBlanksTrimmed asNumber.
	^ (origX@origY corner: cornerX@cornerY).
! !

!Rectangle methodsFor: '*siss-private' stamp: 'yo 3/20/2007 21:54'!
sissIsLiteral

	^ true.
! !

!UniclassScript methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 09:35'!
sissComeFullyUpOnReloadFrom: from to: to

	"currentScriptEditor
		sissComeFullyUpOnReloadFrom: from to: to;
		install;
		dismiss."! !

!UniclassScript methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 16:47'!
sissIgnoreInstVarNames

	^ #(formerScriptingTiles).
! !

!SystemOrganizer class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 19:24'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ SystemOrganization.
! !

!SystemOrganizer methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 19:23'!
sissContentsInto: newElem context: dictionary
! !

!TimesRepeatTile methodsFor: '*siss-interface' stamp: 'sw 6/15/2007 18:36'!
sexpWith: dictionary
	"Answer an SExpElement representing the receiver."

	| n elements e |
	n _ SExpElement keyword: #loop.
	n attributeAt: #type put: 'repeat'.
	elements _ WriteStream on: (Array new: 3).
	e _ SExpElement keyword: #initial.
	e elements: (Array with: ((SExpElement keyword: #literal) attributeAt: #value put: '1'; yourself)).
	elements nextPut: e.
	e _ SExpElement keyword: #increment.
	e elements: (Array with: ((SExpElement keyword: #literal) attributeAt: #value put: '1'; yourself)).
	elements nextPut: e.

	e _ SExpElement keyword: #test.
	self numberOfTimesToRepeatPart submorphs
		ifEmpty:
			[e elements: (Array with: ((SExpElement keyword: #literal) attributeAt: #value put: '0'; yourself))]
		ifNotEmpty:
			[e elements: (Array with: (self numberOfTimesToRepeatPart sexpWith: dictionary))].

	elements nextPut: e.
	
	elements nextPut: (self sexpBlockFor: whatToRepeatPart with: dictionary).
	n elements: elements contents.
	^ n.

! !

!TimesRepeatTile methodsFor: '*siss-interface' stamp: 'yo 2/20/2008 00:04'!
sissComeFullyUpOnReloadFrom: from to: to

	whatToRepeatPart borderWidth: 0; layoutInset: 0; hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		color: Color transparent;
		setNameTo: 'Script to repeat'.! !

!String methodsFor: '*siss-converting' stamp: 'yo 3/8/2007 18:25'!
sissEscape

	^ String streamContents: [:strm |
		self do: [:c |
			strm nextPutAll: c sissSequence
		]
	].
! !

!String methodsFor: '*siss-converting' stamp: 'yo 3/8/2007 21:54'!
sissUnescape

	| result c r v first aStream |
	aStream _ self readStream.
	result _ (String new: self size) writeStream.
	[(c _ aStream next) notNil] whileTrue: [
		c = $\ ifFalse: [
			result nextPut: c.
		] ifTrue: [
			c _ aStream next.
			c = $u ifTrue: [
				r _ 0.
				1 to: 4 do: [:i |
					c _ aStream next asUppercase.
					v _ '0123456789ABCDEF' indexOf: c startingAt: 1 ifAbsent: [self error: ''].
					r _ r * 16 + (v - 1).
				].
				(16rD800 <= r and: [r <= 16rDBFF]) ifTrue: [
					first _ r.
					r _ (aStream next: 6) sissUnescape.
					r _ (r at: 1) charCode.
					r _ (first - 16rD800) * 16r400 + (r - 16rDC00).
					result nextPut: (Character value: r).
				] ifFalse: [
					result nextPut: (Character value: r).
				].
			] ifFalse: [
				c = $x ifTrue: [
					r _ 0.
					1 to: 2 do: [:i |
						c _ aStream next asUppercase.
						v _ '0123456789ABCDEF' indexOf: c startingAt: 1 ifAbsent: [self error: ''].
						r _ r * 16 + (v - 1).
					].
					result nextPut: (Character value: r).
				] ifFalse: [
					result nextPut: c sissUnescape.
				].
			].
		].
	].
	^ result contents.
! !

!TimesRepeatMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 14:03'!
sexpWith: dictionary

	| n elements e |
	n _ SExpElement keyword: #loop.
	n attributeAt: #type put: 'repeat'.
	elements _ WriteStream on: (Array new: 3).
	e _ SExpElement keyword: #initial.
	e elements: (Array with: ((SExpElement keyword: #literal) attributeAt: #value put: '1'; yourself)).
	elements nextPut: e.
	e _ SExpElement keyword: #increment.
	e elements: (Array with: ((SExpElement keyword: #literal) attributeAt: #value put: '1'; yourself)).
	elements nextPut: e.

	e _ SExpElement keyword: #test.
	numberOfTimesToRepeatPart submorphs
		ifEmpty:
			[e elements: (Array with: ((SExpElement keyword: #literal) attributeAt: #value put: '0'; yourself))]
		ifNotEmpty:
			[e elements: (Array with: (numberOfTimesToRepeatPart sexpWith: dictionary))].

	elements nextPut: e.
	
	elements nextPut: (self sexpBlockFor: whatToRepeatPart with: dictionary).
	n elements: elements contents.
	^ n.

! !

!BlockNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:46'!
sexpWith: aDictionary obj: obj

	| elems n |
	elems _ WriteStream on: (Array new: arguments size + 1).
	n _ SExpElement keyword: #sequence.

	1 to: arguments size do: [:i |
		elems nextPut: (SExpElement
							keyword: #parameter
							attributes: (SExpAttributes
											with: #position->i printString
											with: #name->(arguments at: i) key)).
	].

	statements do: [:stmt |
		elems nextPut: (stmt sexpWith: aDictionary obj: obj).
	].

	n addElements: elems contents.
	^ n.
! !

!Preference class methodsFor: '*siss-private' stamp: 'yo 3/26/2008 16:23'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| aName |
	aName _ sexp attributeAt: #name ifAbsent: [].
	aName ifNotNil: [^ Preferences preferenceAt: aName asSymbol].
! !

!Preference methodsFor: '*siss-interface' stamp: 'yo 3/26/2008 16:15'!
sissContentsInto: newElem context: dictionary

	newElem attributeAt: #name put: name.
! !

!Collection methodsFor: '*siss-interface' stamp: 'yo 3/9/2007 10:43'!
sissContentsInto: newElem context: dictionary
	self class isBits ifTrue: [
		self sissBitsInto: newElem context: dictionary.
		^ self.
	].
	self sissWithCollectionEntries ifTrue: [
		self sissIndexFieldsInto: newElem context: dictionary.
		^ self.
	].
	self sissInstVarsInto: newElem context: dictionary.
! !

!Collection methodsFor: '*siss-private' stamp: 'yo 3/3/2007 21:37'!
sissWithBasicAt

	^ false.
! !

!StandardSourceFileArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 15:25'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!RunArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:33'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!RunArray methodsFor: '*siss-interface' stamp: 'yo 2/27/2008 15:17'!
sissExportSpecification

	^ #(('runs' #runs)
		('values' #values)).
! !

!RunArray methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context
! !

!AbstractFont class methodsFor: '*siss-instance creation' stamp: 'tfel 8/7/2016 09:04'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| values familyName size emphasisCode |
	values := ((sexp attributeAt: #value) splitBy: ' ') asOrderedCollection.
	emphasisCode := values removeLast asInteger.
	size := values removeLast asInteger.
	familyName := values joinSeparatedBy: ' '.
	^self familyName: familyName size: size emphasized: emphasisCode.
! !

!AbstractFont methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!AbstractFont methodsFor: '*siss-interface' stamp: 'yo 3/5/2007 11:27'!
sissStoreString

	^ self fontNameWithPointSize, ' ', self emphasis asString! !

!TextStyle class methodsFor: '*siss-interface' stamp: 'tfel 8/5/2016 16:30'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| aName val ret |
	aName _ sexp attributeAt: #value ifAbsent: [].
	aName ifNil: [
		ret _ super sissCreateInstanceFromSexp: sexp idref: idref from: from to: to.
		ret instVarNamed: 'fontArray' put: (TextStyle named: ret fonts first familyName) fonts.
		^ ret.
	].
	val _ (TextStyle named: aName) ifNil: [TextStyle default].
	idref ifNotNil: [to at: idref put: val].
	^ val.
! !

!TextStyle methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 21:32'!
sissContentsInto: newElem context: dictionary
	| orig n |
	n _ self fonts first familyName.
	orig _ (TextStyle named: n).
	(self equals: orig) ifTrue: [
		"This equals: is a wierd one."
		newElem attributeAt: #value put: n.
	] ifFalse: [
		^ super sissContentsInto: newElem context: dictionary
	].
! !

MTokenizer subclass: #MSExpTokenizer
	instanceVariableNames: 'parenMemo parenNextPos nameMemo nameNextPos keywordMemo keywordNextPos stringMemo stringNextPos tokenMemo tokenNextPos tokenizeMemo tokenizeNextPos unicodeOneSequenceMemo unicodeOneSequenceNextPos charOrSequenceMemo charOrSequenceNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SISS-Meta'!

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/8/2007 22:24'!
byteCharCode: u1 and: u2

	^ (('0123456789ABCDEF' indexOf: u1 startingAt: 1 ifAbsent: [0]) - 1) * 16 +
		(('0123456789ABCDEF' indexOf: u2 startingAt: 1 ifAbsent: [0]) - 1).! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/9/2007 13:18'!
charOrSequence ::=
	<anything>:c ?`c = $"` `nil` |
	<anything>:c ?`c ~= $\ and: [c ~= $"]` `c` |
	<anything>:c ?`c = $\` (
		<unicodeOneSequence>:r ?`16rD800 <= r and: [r <= 16rDBFF]` <unicodeOneSequence>:r2 ?`16rDC00 <= r2 and: [r2 <= 16rDFFF]` `Character value: (r - 16rD800) * 16r400 + (r2 - 16rDC00)` |
		<unicodeOneSequence>:r `Character value: r` |
		<anything>:d ?`d = $x` <anything>:u1 <anything>:u2 `Character value: (self byteCharCode: u1 and: u2)` |
		<anything>:d ?`d = $a` `Character value: 7` |
		<anything>:d ?`d = $b` `Character value: 8` |
		<anything>:d ?`d = $t` `Character value: 9` |
		<anything>:d ?`d = $n` `Character value: 10` |
		<anything>:d ?`d = $v` `Character value: 11` |
		<anything>:d ?`d = $f` `Character value: 12` |
		<anything>:d ?`d = $r` `Character value: 13` |
		<anything>:d ?`d = $e` `Character value: 27` |
		<anything>
	):v `v`! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializecharOrSequence
	charOrSequenceMemo _ Array new: stream size + 1 withAll: Untried.
	charOrSequenceNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializekeyword
	keywordMemo _ Array new: stream size + 1 withAll: Untried.
	keywordNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializename
	nameMemo _ Array new: stream size + 1 withAll: Untried.
	nameNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializeparen
	parenMemo _ Array new: stream size + 1 withAll: Untried.
	parenNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializestring
	stringMemo _ Array new: stream size + 1 withAll: Untried.
	stringNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetoken
	tokenMemo _ Array new: stream size + 1 withAll: Untried.
	tokenNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetokenize
	tokenizeMemo _ Array new: stream size + 1 withAll: Untried.
	tokenizeNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializeunicodeOneSequence
	unicodeOneSequenceMemo _ Array new: stream size + 1 withAll: Untried.
	unicodeOneSequenceNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/1/2007 16:36'!
keyword ::=
	$: <name>:n `MToken type: #keyword value: n value`! !

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/1/2007 16:36'!
makeFloat: int and: frac

	| val |
	val _ ((int inject: 0 into: [:subTotal :next | subTotal * 10 + next digitValue]) * 1.0)
		 + (frac reversed inject: 0.0 into: [:subTotal :next | subTotal * 0.1 + (next digitValue * 0.1)]).
	^ MToken type: #float value: val.! !

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/1/2007 16:36'!
makeInt: int 

	| val |
	val _ int inject: 0 into: [:subTotal :next | subTotal * 10 + next digitValue].
	^ MToken type: #integer value: val.! !

!MSExpTokenizer methodsFor: 'private' stamp: 'tfel 8/7/2016 10:12'!
makeNameBeginsWith: aCharacter and: restString

	^ MToken type: #name value: (String newFrom: aCharacter asString, (restString joinSeparatedBy: '')) asSymbol.! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 16:48'!
name ::=
	<char>:c ?`c isLetter` (<char>:d ?`d isAlphaNumeric` `d`)*:s
		`self makeNameBeginsWith: c and: s`! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 16:21'!
paren ::=
	$( `#'('` |
	$) `#')'`! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/8/2007 22:00'!
string ::=
	$" <charOrSequence>*:s $" `MToken type: #string value: (String newFrom: s)`! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/9/2007 13:21'!
token ::=
	<space>* (<paren> | <keyword> | <name> | <string>)! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 16:51'!
tokenize ::=
	<token>*! !

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/8/2007 22:56'!
unicodeCharCode: u1 and: u2 and: u3 and: u4

	^ ((('0123456789ABCDEF' indexOf: u1 startingAt: 1 ifAbsent: [0]) - 1) * 4096) +
		((('0123456789ABCDEF' indexOf: u2 startingAt: 1 ifAbsent: [0]) - 1) * 256) +
			((('0123456789ABCDEF' indexOf: u3 startingAt: 1 ifAbsent: [0]) - 1) * 16) +
				((('0123456789ABCDEF' indexOf: u4 startingAt: 1 ifAbsent: [0]) - 1)).! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/9/2007 13:12'!
unicodeOneSequence ::=
	<anything>:d ?`d = $u` <anything>:u1 <anything>:u2 <anything>:u3 <anything>:u4 `self unicodeCharCode: u1 and: u2 and: u3 and: u4`! !

!Player class methodsFor: '*siss-private' stamp: 'yo 4/6/2007 10:57'!
sissComeFullyUpOnReloadFrom: from to: to

	self slotInfo keys do: [:k |
		self compileInstVarAccessorsFor: k
	].
	super sissComeFullyUpOnReloadFrom: from to: to.
! !

!Player class methodsFor: '*siss-private' stamp: 'yo 3/30/2007 22:22'!
sissInstVarsInto: sexp context: dictionary

	super sissInstVarsInto: sexp context: dictionary.
	sexp attributeAt: #slotsString
		put: (String streamContents: [:strm |
				self instVarNames do: [:e | strm nextPutAll: e] separatedBy: [strm space]]).! !

!Player methodsFor: '*siss-interface' stamp: 'yo 2/27/2008 15:01'!
sissContentsInto: newElem context: dictionary
	| cls |
	super sissContentsInto: newElem context: dictionary.
	(self class isUniClass) ifTrue: [
		cls _ self class sissElementInContext: dictionary.
		cls ifNil: [^ self].
		newElem attributeAt: #uniclass put: cls idref.
	].
! !

!Player methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 16:31'!
sissProxySelector

	^ self costume isWorldMorph ifTrue: [^ #worldPlayer] ifFalse: [^ #yourself].
! !

!MessageNode methodsFor: '*siss-interface' stamp: 'yo 3/24/2007 08:57'!
condSexpWith: aDictionary for: sel obj: obj

	| newElem c y n |

	newElem _ SExpElement keyword: #condition.

	c _ receiver sexpWith: aDictionary obj: obj.
	(sel == #ifTrue: or: [sel == #ifTrue:ifFalse:]) ifTrue: [
		y _ (arguments at: 1) sexpWith: aDictionary obj: obj.
		sel == #ifTrue: ifTrue: [
			n _ SExpElement keyword: #sequence components: #().
		] ifFalse: [
			n _ (arguments at: 2) sexpWith: aDictionary obj: obj.
		].	
	].
	(sel == #ifFalse: or: [sel == #ifFalse:ifTrue:]) ifTrue: [
		n _ (arguments at: 1) sexpWith: aDictionary obj: obj.
		sel == #ifFalse: ifTrue: [
			y _ SExpElement keyword: #sequence components: #().
		] ifFalse: [
			y _ (arguments at: 2) sexpWith: aDictionary obj: obj.
		].	
	].

	newElem addElements: (Array with: c with: y with: n).
	^ newElem.
! !

!MessageNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 11:53'!
sexpWith: aDictionary obj: obj

	| sel elems n e |
	sel _ (selector isSymbol) ifTrue: [selector] ifFalse: [selector key].
	(#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: sel) ifTrue: [
		^ self condSexpWith: aDictionary for: sel obj: obj.
	].
	elems _ WriteStream on: (Array new: arguments size + 1).
	n _ SExpElement keyword: #send.

	e _ SExpElement keyword: #selector.
	e attributeAt: #selector put: sel.
	elems nextPut: e.
	elems nextPut: (receiver sexpWith: aDictionary obj: obj).
	arguments collect: [:a |
		elems nextPut: (a sexpWith: aDictionary obj: obj)
	].
	n addElements: elems contents.
	^ n.
! !

!Fraction class methodsFor: '*siss-instance creation' stamp: 'yo 5/2/2007 07:18'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| stream a b |
	stream _ (sexp attributeAt: #value) readStream.
	stream next = $( ifFalse: [^ 0].
	a _ Integer readFrom: stream.
	stream next = $/ ifFalse: [^ 0].
	b _ Number readFrom: stream.
	^ (a/b).
! !

!BooleanScriptEditor methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:54'!
sexpWith: dictionary

	(submorphs notEmpty and: [submorphs first submorphs notEmpty]) 
		ifTrue: [^ super sexpWith: dictionary].
	^ SExpElement keyword: #literal
		attributes: (SExpAttributes with: #value->'true' with: #type->'Boolean').
! !

!ScriptEditorMorph methodsFor: '*siss-interface' stamp: 'tfel 8/11/2016 09:35'!
sexpScriptWith: aDictionary
	| var pSexp n elements |
	n _ SExpElement keyword: #slot. "script"
	n attributeAt: #name put: 'script'.
	n attributeAt: #scriptName put: scriptName.
	n attributeAt: #type put: 'Player'.
	pSexp _ aDictionary at: playerScripted class ifAbsent: [].
	n attributeAt: #playerClass put: (pSexp ifNotNil: [pSexp idref] ifNil: ['0']).
	n attributeAt: #language put: (self isTextuallyCoded ifTrue: ['Squeak'] ifFalse: ['Etoys']).
	elements _ WriteStream on: (Array new: 20).
	self hasParameter ifTrue: [
		var _ (playerScripted class scripts at: scriptName) argumentVariables first.
		elements nextPut: ((SExpElement keyword: #parameter)
							attributeAt: #type put: var variableType;
							attributeAt: #position put: '1';
							attributeAt: #name put: 'parameter1';
 							yourself).
	].

	self isTextuallyCoded ifFalse: [
		elements nextPut: (self sexpWith: aDictionary).
	] ifTrue: [
		^ (playerScripted class lookupSelector: scriptName)
				ifNil: ["make an empty script"
					(Object >> #yourself) methodNode sexpWith: aDictionary obj: playerScripted class]
				ifNotNil: [:cm | cm methodNode sexpWith: aDictionary obj: playerScripted class].
	].

	n elements: elements contents.
	^ n.! !

!ScriptEditorMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 13:08'!
sexpWith: dictionary
	| n elements |
	n _ SExpElement keyword: #sequence.
	elements _ WriteStream on: (Array new: self tileRows size).
	self tileRows do: [:r | 
		r do: [:m |
			((m isKindOf: TileMorph) or: [(m isKindOf: CompoundTileMorph) or: [m isKindOf: PhraseTileMorph]]) ifTrue: [
			elements nextPut: (m sexpWith: dictionary)]]].
	n elements: elements contents.
	^ n.

! !

!ScriptEditorMorph methodsFor: '*siss-interface' stamp: 'jl 9/21/2016 13:23'!
sissComeFullyUpOnReloadFrom: from to: to

	| sexp isTiles morphs row b o methodNode p |
	(self owner notNil and: [self owner owner notNil and: [self owner owner notNil and: [self owner owner owner isMemberOf: TimesRepeatTile]]]) ifTrue: [^ self].
	(self owner notNil and: [self owner owner notNil and: [self owner owner isKindOf: CompoundTileMorph]]) ifTrue: [^ self].
	sexp _ self valueOfProperty: #script.
	self removeProperty: #script.
	b _ bounds.
	o _ owner.
	p _ playerScripted.
	self initialize.
	bounds _ b.
	owner _ o.
	playerScripted _ p.
	sexp ifNil: [^ self].
	self setMorph: playerScripted costume scriptName: (sexp attributeAt: #scriptName) asSymbol.

	isTiles _ (sexp attributeAt: #language ifAbsent: ['Squeak']) = 'Etoys'.
	isTiles ifTrue: [
		morphs _ (ScriptEditorMorphBuilder context: to playerScripted: playerScripted topEditor: self) fromSexp: (sexp elements detect: [:e | e keyword = #sequence] ifNone: []).
		morphs do: [:e |
			row _ self addNewRow.
			row addMorph: e.
		].
		[self install] on: Error do: [:error |
			self inform: ('Could not load an old script named {1}, had to delete it.' translated format: {self scriptName}).
			self flag: #todo. "Debate this or figure out a better fix" self actuallyDestroyScript]
	] ifFalse: [
		methodNode _ ParseNodeBuilder new script: sexp with: to in: playerScripted costume referenceWorld.
		playerScripted class
			addSelectorSilently: methodNode selector
			withMethod: ([(methodNode generate: (CompiledMethodTrailer empty sourceCode: (methodNode sourceText); yourself))]
				on: Error do: ["Uh-oh, the old script couldn't be compiled..."
					self inform: ('Could not load an old script named {1}, left it blank' translated format: {self scriptName}).
					(Compiler new
						parse: (methodNode selector asString, String cr, '^ self')
						in: playerScripted class
						notifying: nil) generate: (CompiledMethodTrailer empty sourceCode: (methodNode sourceText); yourself)
				]).
		"playerScripted class compileSilently: code classified: 'scripts'."
		self userScriptObject becomeTextuallyCoded.
		(self submorphs copyFrom: 2 to: self submorphs size) do: [:m | m delete].
		self showSourceInScriptor.
		(playerScripted class scripts at: scriptName) currentScriptEditor: self.
		"(self class scripts at: scriptName) formerScriptingTiles self."
	].
	super sissComeFullyUpOnReloadFrom: from to: to.
! !

!ScriptEditorMorph methodsFor: '*siss-interface' stamp: 'yo 2/19/2008 12:11'!
sissExportSpecification
	^ playerScripted ifNotNil: [#(('bounds' #bounds)
		('owner' #owner)
		('playerScripted' #playerScripted)
		)] ifNil: [#()].
! !

!ScriptEditorMorph methodsFor: '*siss-interface' stamp: 'yo 4/6/2007 10:23'!
sissInitializeFrom: sexp from: from to: to
	| varName childInst |
	sexp elements do: [:elem |
		varName _ elem attributeAt: #name ifAbsent: [].
		varName = 'script' ifFalse: [
			childInst _ self fromSexp: elem from: from to: to.
			self sissInstVarNamed: varName put: childInst in: to.
		] ifTrue: [
			self setProperty: #script toValue: elem
		].
	].
! !

!TileCommandWithArgumentMorph methodsFor: '*siss-interface' stamp: 'yo 4/1/2007 16:32'!
sexpWith: aDictionary

	^ playerTile sexpWith: aDictionary.
! !

!SoundBuffer methodsFor: '*siss-private' stamp: 'yo 3/5/2007 14:59'!
sissWriteValue
	"Override if you wish"

	| new |
	new _ self clone.
	new swapHalves.
	^ new.
! !

!StandardViewer class methodsFor: '*siss-instance creation' stamp: 'yo 3/20/2007 16:56'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ nil
! !

!ViewerFlapTab methodsFor: '*siss-interface' stamp: 'yo 3/31/2007 22:17'!
sissWriteValue

	self hibernate.
! !

!Color class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| vals rgb alpha inst |
	vals _ (sexp attributeAt: #value) substrings.
	rgb _ (vals at: 1) asNumber.
	alpha _ (vals at: 2) asNumber.
	alpha = 255 ifTrue: [
		inst _ Color basicNew.
		^ inst setRGB: rgb.
	].
	inst _ TranslucentColor basicNew.
	inst setRgb: rgb alpha: (alpha asFloat / 255.0).
	^ inst.
! !

!Color methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!Color methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:27'!
sissStoreString

	^ rgb printString, ' ', (self privateAlpha printString).
! !

!Symbol methodsFor: '*siss-interface' stamp: 'yo 3/9/2007 11:18'!
sissIsLiteral

	^ true.
! !

!CompoundTileMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 13:44'!
sexpBlockElementsFor: scriptPart with: dictionary

	| rows r |
	rows _ scriptPart tileRows.
	^ Array streamContents: [:strm |
		1 to: rows size do: [:i |
		r _ rows at: i.
			r do: [:t | strm nextPut: (t sexpWith: dictionary)].
		].
	].
! !

!CompoundTileMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 13:45'!
sexpBlockFor: scriptPart with: dictionary

	| n elems |
	n _ SExpElement keyword: #sequence.
	elems _ self sexpBlockElementsFor: scriptPart with: dictionary.
	n elements: elems.
	^ n.
! !

!CompoundTileMorph methodsFor: '*siss-interface' stamp: 'yo 9/7/2007 15:31'!
sexpWith: dictionary

	| n elements test |
	n _ SExpElement keyword: #condition.
	test _ self sexpBlockElementsFor: testPart with: dictionary.
	test ifEmpty: [test _ SExpElement keyword: #sequence elements: #()] ifNotEmpty: [test _ test first].
	elements _ Array
		with: test
		with: (self sexpBlockFor: yesPart with: dictionary)
		with: (self sexpBlockFor: noPart with: dictionary).
	^ n elements: elements.
! !

!CompoundTileMorph methodsFor: '*siss-interface' stamp: 'yo 2/19/2008 23:54'!
sissComeFullyUpOnReloadFrom: from to: to

	testPart borderWidth: 0; layoutInset: 1; color: Color transparent; height: 10; hResizing: #spaceFill.
	yesPart borderWidth: 0; layoutInset: 2; hResizing: #spaceFill; color: Color transparent.
	noPart borderWidth: 0; layoutInset: 2; hResizing: #spaceFill; color: Color transparent.! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/4/2007 16:33'!
bindingOf: varName

	self referencePoolOrNil ifNotNilDo: [:ref |
		^ ref associationAt: varName asSymbol ifAbsent: [nil].
	].
	^ nil.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 11/5/2007 16:54'!
cleanUpReferences

	| all v w before now |
	all _ self presenter reallyAllExtantPlayersNoSort.
	self referencePoolIfPresentDo: [:ref |
		before _ SmallInteger maxVal.
		now _ ref size.
		[before > now] whileTrue: [
			ref keysDo: [:k |
				(v _ ref at: k) ifNil: [ref removeKey: k]
				ifNotNil: [
					v isPlayerLike ifTrue: [
						(all includes: v) ifFalse: [ref removeKey: k]
						ifTrue: [
							((w _ v costume topPasteUp) notNil
								and: [w ~~ self]) ifTrue: [
									w isWorldMorph ifTrue: [ref removeKey: k]]]]]].
			before _ now.
			now _ ref size.
		].
	].
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/5/2007 14:46'!
referencePoolIfPresentDo: aBlock

	^ self valueOfProperty: #References ifPresentDo: aBlock.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/4/2007 16:32'!
referencePoolOrNil

	^ self valueOfProperty: #References ifAbsent: [nil].
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/5/2007 22:41'!
referenceWorldViaOwnwer

	self isWorldMorph ifTrue: [^ self].
	^ super referenceWorldViaOwnwer! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'yo 4/6/2007 13:49'!
sissComeFullyUpOnReloadFrom: from to: to

	(self valueOfProperty: #soundAdditions) ifNotNilDo:
		[:additions | SampledSound assimilateSoundsFrom: additions].
	self removeProperty: #soundAdditions.
	super sissComeFullyUpOnReloadFrom: from to: to.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 10:28'!
sissScanObjectsAsEtoysProject

	| dict ret |
	dict _ SISSDictionaryForScanning new initialize.
	self cleanUpReferences.
	self owner ifNotNil: [dict boundaryObjects add: self owner].
	dict boundaryObjects add: Utilities scrapsBook.
	Utilities scrapsBook pages do: [:p | dict boundaryObjects add: p].
	worldState ifNotNil: [self hands do: [:h | dict boundaryObjects add: h]].
	self project ifNotNil: [self setProperty: #projectVersion toValue: self project currentVersionNumber].
	ret _ dict sissScanObjectsFrom: self.
	self removeProperty: #projectVersion.

	^ ret.
! !

!PasteUpMorph methodsFor: '*siss-interface' stamp: 'tfel 8/11/2016 09:25'!
sissWriteValue
	"Override if you wish"

	| new |
	self prepareToBeSaved.
	new _ self clone.
	new privateSubmorphs: (submorphs reject: [:e |
		e isDockingBar
			or: [(e isKindOf: SolidSugarSuppliesTab)
				or: [(e isKindOf: Viewer)
					or: [(e isKindOf: SugarNavTab)
						or: [((e isKindOf: SystemWindow) and: [(e model isKindOf: Workspace) not])
							or: [(e isMemberOf: FlapTab) and: [e isGlobalFlap]]]]]]]).
	new instVarNamed: 'presenter' put: nil.
	new instVarNamed: 'worldState' put: nil.
	new privateExtension: self extension copy.
	new extension removeOtherProperties.
	self extension otherProperties ifNotNil: [:p | p keysDo: [:sym |
		(#(commandKeySelectors lastKeystroke locked) includes: sym) ifFalse: [
			new setProperty: sym toValue: (self extension valueOfProperty: sym)
		].
	]].

	^ new.! !

!Interval class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 15:08'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Association class methodsFor: '*siss-interface' stamp: 'tfel 8/5/2016 16:21'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| n k className classObj v e |
	n _ self basicNew.
	idref ifNotNil: [to at: idref put: n].
	sexp attributeAt: #keyId ifPresent: [:id |
		k _ self fromSexp: (from at: id asSymbol) from: from to: to.
	] ifAbsent: [
		className _ sexp attributeAt: #keyClass.
		classObj _ self classFromClassName: className.
		e _ SExpElement keyword: className asSymbol attributes: (SExpAttributes with: (#value->(sexp attributeAt: #keyValue))).
		k _ classObj sissCreateInstanceFromSexp: e idref: nil from: from to: to.
	].
	sexp attributeAt: #valueId ifPresent: [:id |
		v _ self fromSexp: (from at: id asSymbol) from: from to: to.
	] ifAbsent: [
		className _ sexp attributeAt: #valueClass.
		classObj _ self classFromClassName: className.
		e _ SExpElement keyword: className asSymbol attributes: (SExpAttributes with: (#value->(sexp attributeAt: #valueValue))).
		v _ classObj sissCreateInstanceFromSexp: e idref: nil from: from to: to.
	].
	^ n key: k value: v.
! !

!Association methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:52'!
sissContentsInto: newElem context: dictionary

	| k v |
	k _ key sissElementInContext: dictionary.
	v _ value sissElementInContext: dictionary.
	key sissIsLiteral ifTrue: [
		newElem attributeAt: #keyClass put: key class name.
		newElem attributeAt: #keyValue put: k.
	] ifFalse: [
		newElem attributeAt: #keyId put: (k attributeAt: #idref).
	].
	value sissIsLiteral ifTrue: [
		newElem attributeAt: #valueClass put: value class name.
		newElem attributeAt: #valueValue put: v.
	] ifFalse: [
		newElem attributeAt: #valueId put: (v attributeAt: #idref).
	].
! !

!KedamaSequenceExecutionStub methodsFor: '*siss-interface' stamp: 'yo 2/27/2008 15:00'!
sissContentsInto: newElem context: dictionary

	| cls |
	self sissChildrenInto: newElem context: dictionary.
	(self class isUniClass) ifTrue: [
		cls _ self class sissElementInContext: dictionary.
		cls ifNil: [^ self].
		newElem attributeAt: #uniclass put: cls idref.
		cls attributeAt: #exemplar put: (newElem elements detect: [:e | (e attributeAt: #name) = 'exampler']) idref.
	].
! !

!ParseNode methodsFor: '*siss-interface' stamp: 'yo 4/13/2007 10:27'!
isEToyBinaryExp

	^ false.
! !

!ParseNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 09:58'!
sexpWith: aDictionary

! !

!KedamaSetColorComponentTile methodsFor: '*siss-interface' stamp: 'yo 4/2/2007 12:44'!
sexpWith: aDictionary

	^ patchTile sexpWith: aDictionary.
! !

!OrderedCollection methodsFor: '*siss-private' stamp: 'yo 3/5/2007 16:52'!
sissInstVarNamed: varName put: childInst
	self addLast: childInst.
	self size ~= varName asNumber ifTrue: [self error: 'wrong order'].
! !

!OrderedCollection methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context
	self addLast: childInst.
	"self size ~= varName asNumber ifTrue: [self error: 'wrong order']."
! !

!OrderedCollection methodsFor: '*siss-private' stamp: 'yo 3/5/2007 16:47'!
sissWithCollectionEntries

	^ true.
! !

!WorldState class methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:08'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| dict ws |
	ws _ self new.
	idref ifNotNil: [to at: idref put: ws].
	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	ws viewBox: (dict at: #viewBox).
	^ ws.
! !

!WorldState methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 15:50'!
sissExportSpecification
	^ #(('viewBox' #viewBox))
! !

!Number class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:58'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| str inst |
	str _ sexp attributeAt: #value.
	inst _ Number readFromString: str.
	^ inst.
! !

!Number methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!PredicatedArray class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 12:00'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!PredicatedArray methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:46'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context! !

!SystemNavigation class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:56'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self default.
! !

!SystemNavigation methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:54'!
sissContentsInto: newElem context: dictionary
! !

!TilePadMorph methodsFor: '*siss-interface' stamp: 'yo 3/15/2007 13:27'!
sexpWith: dictionary
	submorphs size > 1 ifTrue: [self error: ''].
	^ submorphs first sexpWith: dictionary.
! !

!WeakValueAssociation methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	(varName at: 1) isDigit ifTrue: [
		self basicAt: varName asInteger put: childInst
	] ifFalse: [
		self sissBasicInstVarNamed: varName put: childInst in: context
	].
! !

!ClassDescription methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:43'!
sissInstVarsInto: sexp context: dictionary

	| instVars ind ignore elem child result |	
	instVars := self class allInstVarNames.
	ind := Object class allInstVarNames size.
	ignore _ self sissIgnoreInstVarNames.
	instVars _ instVars copyFrom: ind + 1 to: instVars size.
	result _ WriteStream on: (Array new: instVars size).

	sexp attributeAt: #metaclass put: 'true'.

	instVars do: [:nm |
		ind := ind + 1.
		(ignore includes: nm) ifFalse: [
			elem _ self instVarAt: ind.
		] ifTrue: [
			elem _ nil
		].
		child _ elem ifNotNil: [elem sissElementInContext: dictionary] ifNil: [].
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: nm)
		].
	].
	sexp addElements: result contents.
! !

!KedamaGetColorComponentTile methodsFor: '*siss-interface' stamp: 'yo 4/2/2007 13:06'!
sexpWith: aDictionary

	^ patchTile sexpWith: aDictionary.
! !

!Dictionary methodsFor: '*siss-private' stamp: 'yo 3/24/2007 09:45'!
sissIndexFieldsWithDoInto: sexp context: dictionary

	| ind child result |
	ind _ 0.
	result _ WriteStream on: (Array new: self size).
	self associationsDo: [:elem |
		ind := ind + 1.
		child _ elem sissElementInContext: dictionary.
		child ifNotNil: [
			result nextPut: (self sissMakeSlotSexpFor: elem child: child name: ind printString).
		].
	].
	sexp attributeAt: #size put: self size printString.
	sexp addElements: result contents.
! !

!GraphicTile methodsFor: '*siss-interface' stamp: 'yo 4/6/2007 11:45'!
sexpWith: dictionary
	^ SExpElement keyword: #literal
		attributes: (SExpAttributes
					with: #type->'Graphic'
					with: #value->(dictionary at: literal) idref).
! !

!LiteralNode methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 14:45'!
sexpWith: aDictionary obj: obj

	| newElem |
	newElem _ SExpElement keyword: #literal.
	newElem attributeAt: #value put: key asString.
	newElem attributeAt: #type put: key class name.
	^ newElem.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 15:26'!
sissScanObjectsForMorphCopy

	| dict |
	dict _ SISSDictionaryForMorphCopying new initialize.
	dict initializeSubmorphs: self.
	^ dict sissScanObjectsFrom: self.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 11/8/2007 15:29'!
sissScanObjectsWithoutOwner

	| dict |
	dict _ SISSDictionaryForScanning new initialize.
	self owner ifNotNil: [
		dict boundaryObjects add: self owner.
	].
	^ dict sissScanObjectsFrom: self.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:36'!
sissWriteValue

	self prepareToBeSaved.
! !

!Morph methodsFor: '*siss-interface' stamp: 'yo 4/4/2007 16:37'!
uniqueNameForReferenceOrNil

	^ nil.
! !

!RandomNumberTile methodsFor: '*siss-interface' stamp: 'yo 4/1/2007 03:50'!
sexpWith: dictionary
	| n elements |
	n _ SExpElement keyword: #send.
	n attributeAt: #type put: 'Number'.
	elements _ Array with: ((SExpElement keyword: #selector)
					attributeAt: #selector put: 'atRandom'; yourself)
				with: ((SExpElement keyword: #literal)
					attributeAt: #type put: 'Number';
					attributeAt: #value put: literal printString;
					yourself).
	n elements: elements.
	^ n.
! !

!Character class methodsFor: '*siss-instance creation' stamp: 'tfel 8/7/2016 09:06'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| str v |
	str := sexp attributeAt: #value.
	(str first) = $$ ifTrue: [^ str second].
	(str startsWith: 'Character ') ifTrue: [^ Character perform: (str splitBy: ' ') last asSymbol].
	v := Integer readFrom: str readStream.
	^ self value: v.
! !

!Character methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!Character methodsFor: '*siss-interface' stamp: 'tfel 8/7/2016 08:44'!
sissSequence
	"This method omits the language tags.  So, shouldn't be used for WideChars casually."
	| masked s low high escapeBlock |
	masked _ self asInteger bitAnd: 16r1FFFFF.
	masked = 7 ifTrue: [^ '\a'].
	masked = 8 ifTrue: [^ '\b'].
	masked = 9 ifTrue: [^ '\t'].
	masked = 10 ifTrue: [^ '\n'].
	masked = 11 ifTrue: [^ '\v'].
	masked = 12 ifTrue: [^ '\f'].
	masked = 13 ifTrue: [^ '\r'].
	masked = 27 ifTrue: [^ '\e'].
	masked = 34 ifTrue: [^ '\"'].
	"masked = 39 ifTrue: [^ '\''']."
	masked = 92 ifTrue: [^ '\\'].

	(32 <= masked and: [masked < 128]) ifTrue: [
		^ self asString.
	].

	escapeBlock _ [:marker :digits |
		s _ String new: digits + 2.
		s at: 1 put: $\.
		s at: 2 put: marker.
		digits + 2 to: 3 by: -1 do: [:i |
			s at: i put: ('0123456789ABCDEF' at: (masked \\ 16) + 1).
			masked _ masked bitShift: -4
		].
		^ s
	].

	(masked < 32 or: [masked > 127 and: [masked < 256]]) ifTrue: [
		escapeBlock value: $x value: 2.
	].
	((256 <= masked) and: [masked <= 16rFFFF]) ifTrue: [
		escapeBlock value: $u value: 4.
	].
	low _ (masked \\ 16r400) + 16rDC00.
	high _ (masked // 16r400) + 16rD800.
	^ (Character value: high) sissSequence, (Character value: low) sissSequence.
! !

!Character methodsFor: '*siss-private' stamp: 'tfel 8/7/2016 08:43'!
sissStoreString

	self asInteger < 256 ifTrue: [^ self printString].
	^ self asInteger printString.
! !

!Character methodsFor: '*siss-interface' stamp: 'yo 3/9/2007 11:23'!
sissUnescape

	self = $a ifTrue: [^ Character value: 7].
	self = $b ifTrue: [^ Character value: 8].
	self = $t ifTrue: [^ Character value: 9].
	self = $n ifTrue: [^ Character value: 10].
	self = $v ifTrue: [^ Character value: 11].
	self = $f ifTrue: [^ Character value: 12].
	self = $r ifTrue: [^ Character value: 13].
	self = $e ifTrue: [^ Character value: 27].

	^ self.
! !

!Project class methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:13'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	| dict n p |

	dict _ self sissSlotsFromSexp: sexp from: from to: to.
	n _ dict at: #name ifAbsent: [].
	p _ Project named: n.
	p ifNil: [p _ Project newMorphic renameTo: n].
	idref ifNotNil: [to at: idref put: p].
	^ p.
! !

!Project methodsFor: '*siss-interface' stamp: 'yo 3/20/2007 21:03'!
sissExportSpecification

	^ #(('name' #name)
	)
! !

!Matrix class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:07'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Text class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 14:59'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self sissBasicCreateInstanceFromSexp: sexp idref: idref from: from to: to! !

!Text methodsFor: '*siss-private' stamp: 'yo 4/3/2007 10:47'!
sissInstVarNamed: varName put: childInst in: context

	self sissBasicInstVarNamed: varName put: childInst in: context! !

!UndefinedObject class methodsFor: '*siss-instance creation' stamp: 'yo 3/5/2007 11:59'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ nil
! !

!UndefinedObject methodsFor: '*siss-private' stamp: 'yo 3/5/2007 11:31'!
sissIsLiteral

	^ true.
! !

!SystemDictionary class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:53'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ Smalltalk.
! !

!SystemDictionary methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 16:52'!
sissContentsInto: newElem context: dictionary
! !

!FlapTab methodsFor: '*siss-interface' stamp: 'yo 3/28/2008 17:13'!
sissComeFullyUpOnReloadFrom: from to: to

	self isCurrentlyTextual ifTrue: [
		self changeTabText2: labelString
	].! !

!SmalltalkImage class methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:14'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to

	^ self current.
! !

!SmalltalkImage methodsFor: '*siss-interface' stamp: 'yo 3/22/2007 17:13'!
sissContentsInto: newElem context: dictionary
! !

!ByteString class methodsFor: '*siss-instance creation' stamp: 'yo 3/9/2007 11:05'!
sissCreateInstanceFromSexp: sexp idref: idref from: from to: to
	| inst |
	inst _ (sexp attributeAt: #value).
	idref ifNotNil: [to at: idref put: inst].
	^ inst.
! !

!ByteString methodsFor: '*siss-interface' stamp: 'yo 3/23/2007 20:55'!
sissBytesInto: sexp context: dictionary

	sexp attributeAt: #value put: self.
	sexp attributeAt: #basicSize put: self size printString.
! !
